VERSION 5.00
Begin VB.UserControl aicAlphaImage 
   BackStyle       =   0  'Transparent
   CanGetFocus     =   0   'False
   ClientHeight    =   1080
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1080
   ClipBehavior    =   0  'None
   ClipControls    =   0   'False
   HasDC           =   0   'False
   HitBehavior     =   0  'None
   MaskColor       =   &H80000014&
   PropertyPages   =   "aicAlphaImage.ctx":0000
   ScaleHeight     =   72
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   72
   ToolboxBitmap   =   "aicAlphaImage.ctx":0015
   Windowless      =   -1  'True
End
Attribute VB_Name = "aicAlphaImage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Credits/Acknowledgements
'   Relies almost totally on my c32bppDIB Suite project. Credits included in that project
'       http://www.planetsourcecode.com/vb/scripts/ShowCode.asp?txtCodeId=67466&lngWId=1
'   Paul Caton for his thunking routines.
'       Timer callbacks created using his code
' For most current updates/enhancements visit the following:
'   Visit http://www.planet-source-code.com/vb/scripts/ShowCode.asp?txtCodeId=68262&lngWId=1

' NOTE: ALL CLASSES AND MODULES WITHIN THIS CONTROL MAY HAVE BEEN MODIFIED AND SOME
'       ROUTINES REMOVED. FOR THE COMPLETE UP TO DATE VERSIONS OF THESE CLASSES VISIT:
'       http://www.planetsourcecode.com/vb/scripts/ShowCode.asp?txtCodeId=67466&lngWId=1

' See the Usage.RTF file provided for more information
' Last updated: 7 Oct 2007
'   added ICrossTalk, cCrossComm classes for better usercontrol-usercontrol communication
'   added GDI+ IDE-safe thunk routine in cCrossComm
'   reworked zb_AddressOf to reduce overall memory requirements

' Common Public Events
Public Event Click(ByVal Button As Integer)
Public Event DblClick(ByVal Button As Integer)
Public Event MouseExit()
Public Event MouseEnter()
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)

' Custom callbacks
Public Event FadeTerminated(ByVal CurrentOpacity As Long)
' ^^ when FadeInOut is called, this event is fired when the fade has completed
'    Note: It is not fired if the fade was terminated by you


' ///////////////////////////////////////////////////////////////////////
'                       Overview of Properties/Methods
' ///////////////////////////////////////////////////////////////////////
' AutoRedraw. Enables an offscreen DC for the usercontrol to help speed up drawing.
'   -- Overlapped and rotated images are prime candidates as are very large images scaled down to small sizes
' AutoSize. Forces control to size to the scaled image
' ClearImage. Erases the image contained in the control
' Enabled. Allows/prevents control from receiving mouse events
' FadeInOut. Timed gradual change from current opacity to user-defined opacity
' GDIplusEnabled. Returns true if the system can use GDI+
' GDIplusInitialized. Returns true if the usercontol started GDI+
' GetImageBytes. For advanced users. Exposes the control's image as a byte array
'   also can return bytes in a format that can be saved to disk. See ImageType also
' GetImageScales. Returns width/height of the image scaled to passed desired width/height
' GrayScale. Offers several grayscale forumlas to render image against
' HitTest. Offers several options to determine what part of image is "clickable"
' ImageType. Returns the format of the image if KeepOriginalFormat is True
' IntensityOffset.  Lightens or darkens image when rendered
' InversedImage. Toggles between normal and inversed pixel colors
' isMouseOver. Returns if mouse is over image. This is dependent upon HitTest and Enabled
' KeepOriginalFormat. When set, control will cache original image bytes when new image is loaded
' LoadImage_FromArray. Loads image from passed byte array
' LoadImage_FromClipboard. Loads image from clipboard image
' LoadImage_FromFile. Loads image from file name (supports unicode)
' LoadImage_FromHandle. Loads image from an image memory handle
' LoadImage_FromOrignalBytes. If KeepOriginalBytes is True, reloads image from those bytes
' LoadImage_FromResource. Loads an image from a resource file
' LoadImage_FromStdPicture. Loads an image from a stdPicture object
' MaskColor. Used for non-transparent images, color to make transparent
' MaskUsed. Toggle for the MaskColor property
' Mirror. Toggle to mirror the image horizontally/vertically or both
' MouseIcon. Option to set a custom mouse cursor when mouse is over the control
' MousePointer. Enables MouseIcon or selects one of many default cursor shapes
' OffsetImage. Nudges the image, & optionally shadow, n pixels in any direction
' OffsetShadow. Nudges a shadow only n pixels in any direction
' OLEDropMode. Enables the control to act as an OLE drop site
' Opacity. Level of opaqueness for the image. 100 is fully opaque, 0 is transparent
' Rotation. Determines angle of rotation (run time only). RotateEnabled must be True for actual rotation
' RotateEnabled. Boolean whether image will rotate or not.
' ScaleMethod. Determines how image is scaled to control.
' SetImageBytes. For advanced users. Sets image bytes from array. See GetImageBytes
' ShadowColor. The color of the shadow if applied
' ShadowDepth. The depth of the shadow's blur effect if applied
' ShadowEnabled. Toggles whether shadow is applied or not
' ShadowOffsetX. Sets the shadow's horizontal offset. Use OffsetShadow during runtime
' ShadowOffsetY. Sets the shadow's vertical offset. Use OffsetShadow during runtime
' ShadowOpacity. Sets the shadows opaqueness. 100 is fully opaque, 0 is transparent
' StretchQuality. Toggles the quality of resizing interpolations used
' ///////////////////////////////////////////////////////////////////////


'-Callback declarations for Paul Caton thunking magic----------------------------------------------
Private z_CbMem   As Long    'Callback allocated memory address
Private Declare Function GetModuleHandleA Lib "kernel32" (ByVal lpModuleName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function IsBadCodePtr Lib "kernel32" (ByVal lpfn As Long) As Long
Private Declare Function VirtualAlloc Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Private Declare Function VirtualFree Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long
'-------------------------------------------------------------------------------------------------

' Timer and HitTest related APIs
Private Declare Function SetTimer Lib "user32.dll" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32.dll" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Private Declare Function WindowFromPoint Lib "user32.dll" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINTAPI) As Long
Private Declare Function PtInRegion Lib "gdi32.dll" (ByVal hRgn As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function PtInRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function ClientToScreen Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetParent Lib "user32.dll" (ByVal hwnd As Long) As Long

' Drawing related APIs
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32.dll" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32.dll" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetClipBox Lib "gdi32.dll" (ByVal hDC As Long, ByRef lpRect As RECT) As Long
Private Declare Function GetRgnBox Lib "gdi32.dll" (ByVal hRgn As Long, ByRef lpRect As RECT) As Long
Private Declare Function SetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function IntersectRect Lib "user32.dll" (ByRef lpDestRect As RECT, ByRef lpSrc1Rect As RECT, ByRef lpSrc2Rect As RECT) As Long
Private Declare Function OffsetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function OffsetRgn Lib "gdi32.dll" (ByVal hRgn As Long, ByVal X As Long, ByVal Y As Long) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Type MASKUSAGE
    Color As Long           ' current mask color
    Applied As Boolean      ' mask has been applied
    AppliedColor As Long    ' color used to create mask; may not be same as Color
    Source As aiMaskSource  ' mask option: see aiMaskSource enum
End Type
Private Type FADERCONTROL
    tmrAddr As Long         ' AddressOf timer call back procedure
    fStep As Long           ' percent of opacity to change between steps
    fDelay As Long          ' length to delay before next step occurs
    fOpacity As Long        ' final opacity that also terminates the fader
End Type
Private Type SCALEDCOORD
    Left As Long            ' position of image within usercontrol
    Top As Long
    Width As Long           ' size of image within usercontrol
    Height As Long
    RotatedSize As Long     ' when rotated, the size needed to completely rotate image 360 degrees
    xOffset As Long         ' runtime offsets to render image....
    yOffset As Long         '   could be used to shift image when user clicks on it to create a down effect
    OneToOne As Boolean     ' flag used for painting; when image is actual size, faster renders
End Type

Public Enum aiMaskSource
    aiNoMask = 0
    aiUseMaskColor = 1
    aiUseTopLeft = 2
    aiUseTopRight = 3
    aiUseBottomLeft = 4
    aiUseBottomRight = 5
End Enum
Public Enum aiMirrorEnum
    aiMirrorNone = 0
    aiMirrorHorizontal = 1
    aiMirrorVertical = 2
    aiMirrorAll = 3
End Enum
Public Enum aiScaleMethod
    aiScaled = 0
    aiStretch = 1
    aiScaleDownOnly = 2
    aiActualSize = 3
    aiLockScale = 4
End Enum
Public Enum aiGrayScales
    aiNTSCPAL = 1     ' R=R*.299, G=G*.587, B=B*.114 - Default
    aiCCIR709 = 2     ' R=R*.213, G=G*.715, B=B*.072
    aiSimpleAvg = 3   ' R,G, and B = (R+G+B)/3
    aiRedMask = 4     ' uses only the Red sample value: RGB = Red / 3
    aiGreenMask = 5   ' uses only the Green sample value: RGB = Green / 3
    aiBlueMask = 6    ' uses only the Blue sample value: RGB = Blue / 3
    aiRedGreenMask = 7 ' uses Red & Green sample value: RGB = (Red+Green) / 2
    aiBlueGreenMask = 8 ' uses Blue & Green sample value: RGB = (Blue+Green) / 2
    aiNoGrayScale = 0
End Enum
Public Enum aiHitTestStyle  ' see HitTest property
    aiBoundingRgn = 1
    aiEnclosedRgn = 2
    aiShapedRgn = 3
    aiEntireControl = 0
End Enum
Public Enum aiOLEDropMode
    aiDropNone = vbOLEDropNone
    aiDropManual = vbOLEDropManual
End Enum
Public Enum eImageFormatUC    ' source image format
    img_Error = -1  ' no DIB has been initialized
    img_None = 0    ' no image loaded
    img_Bitmap = 1  ' standard bitmap or jpg
    img_Icon = 3    ' standard icon
    img_WMF = 2     ' windows meta file
    img_EMF = 4     ' enhanced WMF
    img_Cursor = 5  ' standard cursor
    img_BmpARGB = 6  ' 32bpp bitmap where RGB is not pre-multiplied
    img_BmpPARGB = 7 ' 32bpp bitmap where RGB is pre-multiplied
    img_IconARGB = 8 ' XP-type icon; 32bpp ARGB
    img_GIF = 9      ' gif; if class.Alpha=True, then transparent GIF
    img_PNG = 10     ' PNG image
    img_PNGicon = 11 ' PNG in icon file (Vista)
    img_CursorARGB = 12 ' alpha blended cursors? do they exist yet?
    img_CheckerBoard = 64 ' image is displaying own checkerboard pattern; no true image
End Enum

Private Enum eProps
    pHiQualty = 1       'HighQuality interpolation
    pAutoStretch = 2    'Auto Stretch
    pAutoSize = 4       'Auto Size
    pAutoRedraw = 8     'Auto Redraw
    pKeepBytes = 16     'Cache original bytes
    pOffscreen = 32     'Offscreen image maintained
    pMasked = 64        'Image is masked for transparency
    pShadowed = 128     'Image has shadow class
    pRotated = 256      'Image can be rotated
End Enum
Private cKeyProps As eProps
Private cBtnClickTracker As Integer    ' tracks button used to trigger click/dblclick events


Private cAngle As Long
Private cHitTest As aiHitTestStyle
Private cRegion As Long     ' used when cHitTest is aiShapedRgn, aiEnclosedRgn
Private cRgnBox As RECT     ' used when cHitTest is aiEntireControl, aiBoundingRgn

Private cGrayScale As aiGrayScales
Private cScaleMode As ScaleModeConstants    ' parent container's scalemode; used for public events
Private cScaleMethod As aiScaleMethod
Private cMirror As aiMirrorEnum
Private cOpacity As Long
Private cIntesity As Single
Private cMask As MASKUSAGE
Private cScaledCoords As SCALEDCOORD

Private cImage As c32bppDIB
Private cOffscreen As c32bppDIB             ' used when AutoRedraw=True

'//Timer & mouse enter/exit related variables
Private cTmrAddrOf As Long
Private cTmrHwnd As Long
Private cTopLeftPos As POINTAPI
Private cFader As FADERCONTROL

'//Shadow options
Private cShadowClass As c32bppDIB           ' used when creating shadows on non-actual size images
Private cShadowColor As Long
Private cShadowOffset As POINTAPI
Private cShadowDepth As Long
Private cShadowOpacity As Long

Private cCrossTalker As cCrossComm
Implements ICrossComm


' This module is grouped/organized into the following sections:
'   Public Properties & Functions
'   Property Page Routines
'   Inter-Control Communication
'   Support/Helper Routines
'   Usercontrol Properties
'   Callback Thunking Routines
'=========================================================================================================
' /////////////////////// P U B L I C   P R O P E R T I E S  &  F U N C T I O N S \\\\\\\\\\\\\\\\\\\\\\\\
'=========================================================================================================

Public Sub ClearImage()
    ' Purpose: Permanently remove the control's image source
    If ((cKeyProps And pOffscreen) = pOffscreen) Then Set cOffscreen = Nothing
    cImage.DestroyDIB
    Set cShadowClass = Nothing
    If Ambient.UserMode = True Then
        UserControl.Refresh
    Else ' can be called by the property page during design time
        cImage.InitializeDIB cScaledCoords.Width, cScaledCoords.Height
        cImage.CreateCheckerBoard
        sptResize
    End If
End Sub

Public Sub Refresh()
    On Error Resume Next
    ' attempt to get actual scalemode. Errors occur when container has no scalemode (i.e.,frame)
    cScaleMode = UserControl.Parent.ScaleMode
    If Err Then
        Err.Clear
        cScaleMode = vbContainerPosition
        '^^ the above can be used for any scalemode; however, when container scalemode is
        ' vbTwips or vbPixels, the returned X,Y coordinates passed back are decimal not integer
    End If
    On Error GoTo 0
    ' Purpose: Simply refresh the control
    UserControl.Refresh
   
End Sub

Public Function LoadImage_FromArray(inStream() As Byte, Optional desiredIconWidth As Long, Optional desiredIconHeight As Long, Optional desiredIconBitDepth As Long) As Boolean
    ' Purpose. Load an image from array
    If desiredIconHeight < 1 Then desiredIconHeight = UserControl.ScaleHeight
    If desiredIconWidth < 1 Then desiredIconWidth = UserControl.ScaleWidth
    If desiredIconBitDepth < 1 Then desiredIconBitDepth = 32&
    If cImage.LoadPicture_Stream(inStream, desiredIconWidth, desiredIconHeight, , , ((cKeyProps And pKeepBytes) = pKeepBytes), desiredIconBitDepth) Then
        sptReplaceImage
        LoadImage_FromArray = True
    End If
End Function
Public Function LoadImage_FromFile(FileName As String, Optional desiredIconWidth As Long, Optional desiredIconHeight As Long, Optional desiredIconBitDepth As Long) As Boolean
    ' Purpose. Load an image from a file
    If desiredIconHeight < 1 Then desiredIconHeight = UserControl.ScaleHeight
    If desiredIconWidth < 1 Then desiredIconWidth = UserControl.ScaleWidth
    If desiredIconBitDepth < 1 Then desiredIconBitDepth = 32&
    If cImage.LoadPicture_File(FileName, desiredIconWidth, desiredIconHeight, ((cKeyProps And pKeepBytes) = pKeepBytes), desiredIconBitDepth) Then
        sptReplaceImage
        LoadImage_FromFile = True
    End If
End Function
Public Function LoadImage_FromStdPicture(stdPic As StdPicture) As Boolean
    ' Purpose. Load an image from stdPicture object
    If cImage.LoadPicture_StdPicture(stdPic) = True Then
        If ((cKeyProps And pKeepBytes) = pKeepBytes) Then
            Dim srcData() As Byte
            cImage.SaveToStream srcData
            cImage.SetOriginalFormat srcData
        End If
        sptReplaceImage
        LoadImage_FromStdPicture = True
    End If
End Function
Public Function LoadImage_FromClipboard() As Boolean
    ' Purpose. Load an image from the clipboard
    If cImage.LoadPicture_ClipBoard() Then
        If ((cKeyProps And pKeepBytes) = pKeepBytes) Then
            Dim srcData() As Byte
            cImage.SaveToStream srcData
            cImage.SetOriginalFormat srcData
            Erase srcData()
        End If
        sptReplaceImage
        LoadImage_FromClipboard = True
    End If
End Function
Public Function LoadImage_FromHandle(Handle As Long) As Boolean
    ' Purpose. Load an image from an image handle
    If cImage.LoadPicture_ByHandle(Handle) Then
        If ((cKeyProps And pKeepBytes) = pKeepBytes) Then
            Dim srcData() As Byte
            cImage.SaveToStream srcData
            cImage.SetOriginalFormat srcData
        End If
        sptReplaceImage
        LoadImage_FromHandle = True
    End If
End Function
Public Function LoadImage_FromResource(VBglobal As IUnknown, ResSection As Variant, ResID As Variant, Optional desiredIconWidth As Long, Optional desiredIconHeight As Long, Optional desiredIconBitDepth As Long) As Boolean
    ' Purpose. Load an image from a resource file
    
    ' Pass VBglobal like so:  VB.Global
    ' Pass ResSection as: vbResBitmap, vbResIcon, "Custom", etc
    ' Pass ResID as:  101, "MyLogo", etc
    If desiredIconHeight < 1 Then desiredIconHeight = UserControl.ScaleHeight
    If desiredIconWidth < 1 Then desiredIconWidth = UserControl.ScaleWidth
    If desiredIconBitDepth < 1 Then desiredIconBitDepth = 32&
    If cImage.LoadPicture_Resource(ResID, ResSection, VBglobal, desiredIconWidth, desiredIconHeight, , , desiredIconBitDepth) Then
        sptReplaceImage
        LoadImage_FromResource = True
    End If
End Function
Public Function LoadImage_FromOrignalBytes(Optional desiredIconWidth As Long, Optional desiredIconHeight As Long, Optional desiredIconBitDepth As Long) As Boolean
    ' Purpose. Load an image from a file
    If desiredIconHeight < 1 Then desiredIconHeight = UserControl.ScaleHeight
    If desiredIconWidth < 1 Then desiredIconWidth = UserControl.ScaleWidth
    If desiredIconBitDepth < 1 Then desiredIconBitDepth = 32&
    If cImage.LoadPicture_FromOrignalFormat(desiredIconWidth, desiredIconHeight, desiredIconBitDepth) Then
        sptReplaceImage
        LoadImage_FromOrignalBytes = True
    End If
End Function

Public Function GetImageBytes(imgBytes() As Byte, ByRef scanWidth As Long, _
                                Optional ByVal asArray2D As Boolean = False, _
                                Optional ByVal asBGRformat As Boolean = True, _
                                Optional ByVal asBottomUp As Boolean = False, _
                                Optional ByVal asPreMultiplied As Boolean = False, _
                                Optional ByVal asFileFormat As Boolean = False) As Boolean
    
    ' Purpose: Return the DIB bytes in a 1 or 2 dimensional array
    ' Return value is false if no image exists
    
    ' [Parameters].
    ' imgBytes(): a dynamic byte array; will be redimensioned as needed
    ' scanWidth: placeholder for the scan width of the bytes returned
    ' asArray2D: if True, arrays is returned as (x,y) else array is 1 dimensional
    '   see asFileFormat for an exception
    ' asBGRformat: if True, bytes are BGRA else bytes are RGBA
    ' asBottomUp: if True, first byte is bottom,left of image else is top,left of image
    ' asPremultiplied: if True, bytes are in premultiplied format else they are not
    ' asFileFormat: if True, the array is zero-bound and one dimensional only
    '   no other parameters are used. The array can be saved to disk as a file
    '   Call ImageType property first to determine what image format the bytes
    '   will be returned as
    
    If Not (cImage.ImageType = imgError Or cImage.ImageType = imgNone) Then
    
        If Not cImage.ImageType = imgCheckerBoard Then
            If asFileFormat = True Then
                If cImage.GetOrginalFormat(imgBytes) = False Then
                    If cImage.isGDIplusEnabled Or cImage.isZlibEnabled Then
                        GetImageBytes = cImage.SaveToStream_PNG(imgBytes)
                    Else
                        GetImageBytes = cImage.SaveToStream(imgBytes)
                    End If
                End If
            Else
                scanWidth = cImage.scanWidth
                GetImageBytes = cImage.GetDIBbits(imgBytes, asArray2D, asBGRformat, True, True, asBottomUp, , , , , asPreMultiplied)
            End If
        End If
        
    End If
End Function
Public Function SetImageBytes(imgBytes() As Byte, _
                                Optional ByVal isBGRformat As Boolean = True, _
                                Optional ByVal isBottomUp As Boolean = False) As Boolean
    
    ' Purpose: Sets the DIB bytes with the passed modified bytes and refresh image
    ' Return value is True if the bytes were applied
    
    ' [Parameters].
    ' imgBytes(): a dynamic byte array; must be 1 or 2 dimensional
    ' isBGRformat: if True, bytes are BGRA else bytes are RGBA
    ' isBottomUp: if True, first byte is bottom,left of image else is top,left of image
    
    If Not (cImage.ImageType = imgError) Then
        If cImage.SetDIBbits(imgBytes, isBGRformat, , , isBottomUp) = True Then
            If sptUpdateOffscreen(False, True) = False Then sptRefreshRegion
            If Me.ShadowEnabled Then sptRefreshShadow
            UserControl.Refresh
            SetImageBytes = True
        End If
    End If
End Function

Public Sub GetImageScales(ByRef Width As Long, ByRef Height As Long, _
            Optional ByVal ScaleMethod As aiScaleMethod = -1, _
            Optional ByVal desiredWidth As Long, Optional ByVal desiredHeight As Long, _
            Optional ByVal asRotatedImage As Boolean = False)
            
    ' Purpose: Return the size of the image that will fit within the passed
    '       DC dimensions using the passed scale method
    ' Notes:
    '   1. Parameters are pixels
    '   2. To resize your control to allow full rotation, use Sqr(Width*Width+Height*Height)
    
    ' [Parameters]
    '   Width. Variable to hold the returned scaled width
    '   Height. Variable to hold the returned scaled height
    '   ScaleMethod. If -1 then the current scale method will be used else the passed method
    '   desiredWidth. The desired width. If not passed, the current usercontrol width is used
    '   desiredHeight.  The desired height. If not passed, the current usercontrol height is used
    '   asRotatedImage. Indicates the desired width/height allows full 360 degree rotation
    
    If cImage.Handle = 0& Then Exit Sub
            
    If ScaleMethod < aiScaled Then
        ScaleMethod = cScaleMethod
    ElseIf ScaleMethod > aiLockScale Then
        ScaleMethod = aiLockScale
    End If
    
    If ScaleMethod = aiLockScale Then
        Width = cScaledCoords.Width
        Height = cScaledCoords.Height
        Exit Sub
    End If
    
    If desiredWidth < 1 Then desiredWidth = UserControl.ScaleWidth
    If desiredHeight < 1 Then desiredHeight = UserControl.ScaleHeight
    
    Dim xRatio As Single, yRatio As Single
    Dim rotSize As Long
    
    If asRotatedImage Then
        If ScaleMethod = aiActualSize Then
            Width = cImage.Width
            Height = cImage.Height
        Else
            rotSize = Sqr(cImage.Width * cImage.Width + cImage.Height * cImage.Height)
            xRatio = cImage.Width / rotSize
            yRatio = cImage.Height / rotSize
            Select Case ScaleMethod
            Case aiStretch
                Width = desiredWidth * xRatio
                Height = desiredHeight * yRatio
            Case Else
                If desiredWidth > desiredHeight Then
                    rotSize = desiredHeight
                Else
                    rotSize = desiredWidth
                End If
                Width = rotSize * xRatio
                Height = rotSize * yRatio
                If ScaleMethod = aiScaleDownOnly Then
                    If Width > cImage.Width Or Height > cImage.Height Then
                        Width = cImage.Width
                        Height = cImage.Height
                    End If
                End If
            End Select
        End If
    Else
        Select Case ScaleMethod
        Case aiActualSize
            Width = cImage.Width
            Height = cImage.Height
        Case aiStretch
            Width = desiredWidth
            Height = desiredHeight
        Case Else
            xRatio = desiredWidth / cImage.Width
            yRatio = desiredHeight / cImage.Height
            If yRatio < xRatio Then xRatio = yRatio
            If ScaleMethod = aiScaleDownOnly Then
                If xRatio > 1 Then xRatio = 1
            End If
            Width = cImage.Width * xRatio
            Height = cImage.Height * xRatio
        End Select
    End If
    
End Sub
            
Public Property Get ImageType() As eImageFormatUC
    ' Useful if you want to call GetImageBytes to return the image in file format for saving.
    ' Call this property first to determine the format to be returned by GetImageBytes
    If cImage.ImageType = imgError Or cImage.ImageType = imgNone Or cImage.ImageType = imgCheckerBoard Then
        ImageType = imgNone
    ElseIf (cKeyProps And pKeepBytes) = pKeepBytes Then ' original format kept
        ImageType = cImage.ImageType
    ElseIf cImage.isGDIplusEnabled = True Then
        ImageType = imgPNG
    ElseIf cImage.isZlibEnabled = True Then
        ImageType = imgPNG
    ElseIf cImage.Alpha = True Then
        ImageType = imgBmpPARGB
    Else
        ImageType = imgBitmap
    End If
End Property
Public Sub FadeInOut(ByVal FinalOpacity As Long, Optional ByVal FadeStepPercent As Long = 10, Optional ByVal FadeDelayInterval As Long = 30)
    
    ' Purpose: Fade an image from one opacity to another at a stepped percentage while delaying n milliseconds between steps
    ' Note: all values should be positive numbers. Routines will double check and adjust as needed
    
    ' [Parameters]
    ' FinalOpacity: The opacity of the image when the fader terminates
    ' FadeStepPercent: What percentage of opaqueness image should change between intervals (valid values are 1 to 100)
    ' FadeDelayInterval: How long image should remain before next fade step occurs (valid values are 10 to max long value)
    
    ' Kill current fader if it exists
    If Not cFader.fStep = 0& Then
        KillTimer cTmrHwnd, -ObjPtr(Me)
        cFader.fStep = 0&
    End If
    
    ' validate final opacity parameters
    If FinalOpacity < 0& Then
        FinalOpacity = 0&
    ElseIf FinalOpacity > 100& Then
        FinalOpacity = 100&
    End If
    ' validate step value
    If FadeStepPercent = 0& Then
        Exit Sub
    Else
        ' set up fader control
        If Not cOpacity = FinalOpacity Then
            If FinalOpacity < cOpacity Then
                FadeStepPercent = -Abs(FadeStepPercent) ' must be negative
            Else
                FadeStepPercent = Abs(FadeStepPercent)  ' else must be positive
            End If
            With cFader
                ' get AddressOf for our fader timer
                If .tmrAddr = 0& Then .tmrAddr = zb_AddressOf(2, 4, 1)
                .fOpacity = FinalOpacity        ' set final opacity value
                .fStep = FadeStepPercent        ' set fader step value
                If FadeDelayInterval < 10 Then  ' set fader interval
                    .fDelay = 10
                Else
                    .fDelay = FadeDelayInterval
                End If
            End With
            ' fire first fader event
            Call Timer_Fader(cTmrHwnd, 0&, -ObjPtr(Me), 0&)
        End If
    End If
    
End Sub

Public Property Let AutoRedraw(Enable As Boolean)
    ' Purpose: create/maintain a scaled/drawn image in its own DC.
    ' Although it uses more resources, images are rendered much faster since they
    ' to not have to be resized, rotated, mirrored, etc, each time the control must be updated
    ' Additionally, since the cached image is now at a 1:1 ratio, rendering only occurs to
    ' the invalidated portion of the control, not the entire control each time
    If Not (((cKeyProps And pAutoRedraw) = pAutoRedraw) = Enable) Then
        cKeyProps = cKeyProps Xor pAutoRedraw
        If Ambient.UserMode = True Then
            cKeyProps = cKeyProps Xor pOffscreen
            If Enable = False Then Set cOffscreen = Nothing
        End If
        PropertyChanged "AutoRedraw"
    End If
End Property
Public Property Get AutoRedraw() As Boolean
    AutoRedraw = ((cKeyProps And pAutoRedraw) = pAutoRedraw)
End Property

Public Property Let HitTest(Style As aiHitTestStyle)
    ' Determines whether the mouse in the control registers as within the image
    ' Possible values are:
    ' - aiEntireControl. Mouse anywhere within the control is allowed
    ' - aiShapedRgn. Mouse on any non-transparent pixel is allowed
    ' - aiBoundingRgn. Mouse within the tightest rectangle around image is valid
    ' - aiEnclosedRgn. Same as aiShapedRgn but any transparent pixels that fall
    '       between non-transparent pixels is considered non-transparent
    If Style >= aiEntireControl And Style <= aiShapedRgn Then
        If Not Style = cHitTest Then
            cHitTest = Style
            sptRefreshRegion
            PropertyChanged "HitTest"
        End If
    End If
End Property
Public Property Get HitTest() As aiHitTestStyle
    HitTest = cHitTest
End Property

Public Property Let MaskColor(Color As OLE_COLOR)
    ' Allows making a color within a non-transparent bitmap transparent
    If cMask.Applied Then ' previous mask already applied, remove it
        If cMask.Source = aiUseMaskColor Then
            sptUndoMask
            If (cKeyProps And pMasked) = pMasked Then
                cImage.MakeTransparent sptConvertSysColor(Color) Xor vbWhite
            Else
                cImage.MakeTransparent sptConvertSysColor(Color)
            End If
            cMask.AppliedColor = Color
            If sptUpdateOffscreen(False, True) = False Then sptRefreshRegion
            If Me.ShadowEnabled Then sptRefreshShadow
            UserControl.Refresh
        End If
    End If
    cMask.Color = Color
    PropertyChanged "MaskColor"
End Property
Public Property Get MaskColor() As OLE_COLOR
    MaskColor = cMask.Color
End Property

Public Property Let MaskUsed(Style As aiMaskSource)
    ' Enables the mask to take effect.
    ' Only applies to non-transparent images
    If cMask.Applied = False And cImage.Alpha = True Then Exit Property
    If Style >= aiNoMask And Style <= aiUseBottomRight Then
        If Not cMask.Source = Style Then
            If Not cImage.ImageType = imgCheckerBoard Then
                Dim mColor As Long
                If cMask.Applied Then sptUndoMask
                If Style = aiNoMask Then
                    cMask.Applied = False
                Else
                    Select Case Style
                    Case aiUseMaskColor
                        cMask.AppliedColor = cMask.Color
                    Case aiUseBottomLeft
                        cMask.AppliedColor = cImage.GetPixel(0, cImage.Height - 1, , False)
                    Case aiUseBottomRight
                        cMask.AppliedColor = cImage.GetPixel(cImage.Width - 1, cImage.Height - 1, , False)
                    Case aiUseTopLeft
                        cMask.AppliedColor = cImage.GetPixel(0, 0, , False)
                    Case aiUseTopRight
                        cMask.AppliedColor = cImage.GetPixel(cImage.Width - 1, 0, , False)
                    End Select
                    cMask.Applied = True
                    If (cKeyProps And pMasked) = pMasked Then
                        If Style = aiUseMaskColor Then
                            mColor = sptConvertSysColor(cMask.AppliedColor) Xor vbWhite
                        Else
                            mColor = cMask.AppliedColor
                            cMask.AppliedColor = mColor Xor vbWhite
                        End If
                    Else
                        mColor = sptConvertSysColor(cMask.AppliedColor)
                    End If
                    cImage.MakeTransparent mColor
                End If
                If sptUpdateOffscreen(False, True) = False Then sptRefreshRegion
                If Me.ShadowEnabled Then sptRefreshShadow
                UserControl.Refresh
                cMask.Source = Style
                PropertyChanged "MaskUsed"
            End If
        End If
    End If
End Property
Public Property Get MaskUsed() As aiMaskSource
    MaskUsed = cMask.Source
End Property

Public Property Let InversedImage(Inverse As Boolean)
    ' Purpose: Inverts the colors of an image. Can be toggled
    If Not (((cKeyProps And pMasked) = pMasked) = Inverse) Then
        cKeyProps = cKeyProps Xor pMasked
        cImage.MakeImageInverse
        PropertyChanged "InversedImage"
        sptUpdateOffscreen False, False
        UserControl.Refresh
    End If
End Property
Public Property Get InversedImage() As Boolean
    InversedImage = ((cKeyProps And pMasked) = pMasked)
End Property

Public Property Let AutoSize(Value As Boolean)
    ' Purpose: Forces control to resize to the scaled image size
    If Not (((cKeyProps And pAutoSize) = pAutoSize) = Value) Then
        cKeyProps = cKeyProps Xor pAutoSize
        sptResize
        PropertyChanged "AutoSize"
    End If
End Property
Public Property Get AutoSize() As Boolean
    AutoSize = ((cKeyProps And pAutoSize) = pAutoSize)
End Property

Public Property Let ScaleMethod(Method As aiScaleMethod)
    ' Purpose: Determine whether image is scaled proportionally or not
    If Not Method = cScaleMethod Then
        cScaleMethod = Method
        Call sptResize
        PropertyChanged "Stretch"
    End If
End Property
Public Property Get ScaleMethod() As aiScaleMethod
    ScaleMethod = cScaleMethod
End Property

Public Property Let StretchQuality(highQuality As Boolean)
    ' Determines algoritm to use when stretching an image
    If Not (((cKeyProps And pHiQualty) = pHiQualty) = highQuality) Then
        cKeyProps = cKeyProps Xor pHiQualty
        cImage.HighQualityInterpolation = highQuality
        UserControl.Refresh
        PropertyChanged "StretchQuality"
    End If
End Property
Public Property Get StretchQuality() As Boolean
    StretchQuality = ((cKeyProps And pHiQualty) = pHiQualty)
End Property

Public Property Let Opacity(ByVal Opaqueness As Long)
    ' Purpose: Set how opaque the image will be rendered at; 100=fully opaque, 0=fully transparent
    If Not Opaqueness = 0 Then
        Opaqueness = Abs(Opaqueness) Mod 100
        If Opaqueness = 0 Then Opaqueness = 100
    End If
    cOpacity = Opaqueness
    PropertyChanged "Opacity"
    UserControl.Refresh
End Property
Public Property Get Opacity() As Long
    Opacity = cOpacity
End Property

Public Property Let Mirror(MirrorType As aiMirrorEnum)
    ' Purpose. Mirror an image horizontally or vertically or both
    If MirrorType >= aiMirrorNone And MirrorType <= aiMirrorAll Then
        sptMirrorImage MirrorType
        cMirror = MirrorType
        If sptUpdateOffscreen(False, True) = False Then sptRefreshRegion
        If Me.ShadowEnabled Then sptRefreshShadow
        UserControl.Refresh
        PropertyChanged "Mirror"
    End If
End Property
Public Property Get Mirror() As aiMirrorEnum
    Mirror = cMirror
End Property

Public Property Let KeepOriginalFormat(Keep As Boolean)
    ' Forces routines to keep a copy of the image in its original format
    ' This will be used more in upcoming versions
    If Not (((cKeyProps And pKeepBytes) = pKeepBytes) = Keep) Then
        cKeyProps = cKeyProps Xor pKeepBytes
        PropertyChanged "KeepOriginalFormat"
    End If
End Property
Public Property Get KeepOriginalFormat() As Boolean
    KeepOriginalFormat = ((cKeyProps And pKeepBytes) = pKeepBytes)
End Property

Public Property Let grayScale(Style As aiGrayScales)
    ' Option to toggle grayscale effect
    ' Note: offsetting -1/+1 to align values with the c32bppDIB enumeration
    ' That enumeration does not have a "No Grayscale" option
    If Style >= aiNoGrayScale And Style <= aiBlueGreenMask Then
        If Not cGrayScale = Style - 1 Then
            cGrayScale = Style - 1
            UserControl.Refresh
            PropertyChanged "GrayScale"
        End If
    End If
End Property
Public Property Get grayScale() As aiGrayScales
    grayScale = cGrayScale + 1
End Property

Public Property Let RotateEnabled(canRotate As Boolean)
    If Not (((cKeyProps And pRotated) = pRotated) = Abs(canRotate)) Then
        cKeyProps = cKeyProps Xor pRotated
        sptResize
        PropertyChanged "RotateEnabled"
    End If
End Property
Public Property Get RotateEnabled() As Boolean
    RotateEnabled = ((cKeyProps And pRotated) = pRotated)
End Property

Public Property Let Rotation(ByVal newAngle As Long)
    ' Purpose: Rotate an image by set a degree (-360 to 360)
    newAngle = newAngle Mod 360
    If Not cAngle = newAngle Then
        cAngle = newAngle
        If (cKeyProps And pRotated) = pRotated Then
            If sptUpdateOffscreen(False, True) = False Then sptRefreshRegion
            If Me.ShadowEnabled Then sptRefreshShadow
            UserControl.Refresh
            PropertyChanged "Rotation"
        End If
    End If
End Property
Public Property Get Rotation() As Long
    Rotation = cAngle
End Property

Public Property Let Enabled(Enable As Boolean)
    ' Purpose: Enable/Disable mouse events
    If Not UserControl.Enabled = Enable Then
        UserControl.Enabled = Enable
        If Ambient.UserMode = True Then
            If Enable = True Then
                cCrossTalker.AddRef ObjPtr(Me)
            Else
                If UserControl.Tag = "Timer" Then
                    KillTimer cTmrHwnd, ObjPtr(Me)
                    UserControl.Tag = vbNullString
                End If
                cCrossTalker.RemoveRef ObjPtr(Me)
            End If
            sptRefreshRegion
        End If
        PropertyChanged "Enabled"
    End If
End Property
Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property

Public Property Let ShadowEnabled(Enable As Boolean)
    If Not (((cKeyProps And pShadowed) = pShadowed) = Enable) Then
        cKeyProps = cKeyProps Xor pShadowed
        sptRefreshShadow
        PropertyChanged "ShadowEnabled"
        UserControl.Refresh
    End If
End Property
Public Property Get ShadowEnabled() As Boolean
    ShadowEnabled = Abs((cKeyProps And pShadowed) = pShadowed)
End Property

Public Property Let ShadowColor(Color As OLE_COLOR)
    If Not ShadowColor = Color Then
        cShadowColor = Color
        sptRefreshShadow
        PropertyChanged "ShadowColor"
        UserControl.Refresh
    End If
End Property
Public Property Get ShadowColor() As OLE_COLOR
    ShadowColor = cShadowColor
End Property

Public Property Let ShadowOffsetX(Offset As Long)
    If Not cShadowOffset.X = Offset Then
        cShadowOffset.X = Offset
        If Me.ShadowEnabled Then UserControl.Refresh
        PropertyChanged "ShadowOffsetX"
    End If
End Property
Public Property Get ShadowOffsetX() As Long
    ShadowOffsetX = cShadowOffset.X
End Property
Public Property Let ShadowOffsetY(Offset As Long)
    If Not cShadowOffset.Y = Offset Then
        cShadowOffset.Y = Offset
        If Me.ShadowEnabled Then UserControl.Refresh
        PropertyChanged "ShadowOffsetY"
    End If
End Property
Public Property Get ShadowOffsetY() As Long
    ShadowOffsetY = cShadowOffset.Y
End Property

Public Property Let ShadowDepth(Depth As Long)
    If Not cShadowDepth = Depth Then
        If Depth > -1 And Depth < 11 Then
            cShadowDepth = Depth
            sptRefreshShadow
            PropertyChanged "ShadowDepth"
            UserControl.Refresh
        End If
    End If
End Property
Public Property Get ShadowDepth() As Long
    ShadowDepth = cShadowDepth
End Property

Public Property Let ShadowOpacity(Opaqueness As Long)
    If Not cShadowOpacity = Opaqueness Then
        If Opaqueness > -1 And Opaqueness < 101 Then
            cShadowOpacity = Opaqueness
            If Me.ShadowEnabled Then UserControl.Refresh
            PropertyChanged "ShadowOpacity"
        End If
    End If
End Property
Public Property Get ShadowOpacity() As Long
    ShadowOpacity = cShadowOpacity
End Property
    
Public Property Let MousePointer(Pointer As MousePointerConstants)
    ' same as VB's MousePointer property
    On Error Resume Next
    UserControl.MousePointer = Pointer
    If Err Then Err.Clear
    PropertyChanged "MousePointer"
End Property
Public Property Get MousePointer() As MousePointerConstants
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MouseIcon(Icon As StdPicture)
    ' same as VB's MouseIcon property
    Set Me.MouseIcon = Icon
End Property
Public Property Set MouseIcon(Icon As StdPicture)
    On Error Resume Next
    Set UserControl.MouseIcon = Icon
    If Err Then Err.Clear
    PropertyChanged "MouseIcon"
End Property
Public Property Get MouseIcon() As StdPicture
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Let OLEDropMode(Value As aiOLEDropMode)
    ' same as VB's OLEDropMode property
    ' Will forward the OLEDragOver, OLEDragDrop when set
    ' You can use this to allow the control to load an image dragged onto it
    On Error Resume Next
    UserControl.OLEDropMode = Value
    If Err Then Err.Clear
    PropertyChanged "OLEDropMode"
End Property
Public Property Get OLEDropMode() As aiOLEDropMode
    OLEDropMode = UserControl.OLEDropMode
End Property

Public Sub OffsetShadow(X As Long, Y As Long)
    ' sets the shadow offsets in one call preventing multiple refreshes
    cShadowOffset.X = X
    cShadowOffset.Y = Y
    If Me.ShadowEnabled = True Then UserControl.Refresh
End Sub

Public Sub OffsetImage(ByVal SetOffsets As Boolean, ByRef X As Long, ByRef Y As Long, Optional ByRef ShadowX As Long = 0&, Optional ByRef ShadowY As Long = 0&)
    
    ' sets/returns the current offsets of the image and optionally the shadow
    ' When SetOffsets=True then the image/shadow offsets are modified
    ' When SetOffset=False then the image/shadow offsets are returned
    
    ' The offsets are from the normal position. So if you supply 1,1 then the image will
    ' be shifted one pixel right and down from its normal position, not its current position.
    ' And if you supply 0,0, then the image is shifted back to its normal position.
    
    If SetOffsets Then
        cScaledCoords.xOffset = X
        cScaledCoords.yOffset = Y
        If Not ShadowX = 0 Then cShadowOffset.X = ShadowX
        If Not ShadowY = 0 Then cShadowOffset.Y = ShadowY
        If cRegion = 0& Then
            OffsetRect cRgnBox, -cRgnBox.Left + X, -cRgnBox.Top + Y
        Else
            GetRgnBox cRegion, cRgnBox
            OffsetRgn cRegion, -cRgnBox.Left + X, -cRgnBox.Top + Y
        End If
        UserControl.Refresh
    Else
        If cRegion = 0& Then GetRgnBox cRegion, cRgnBox
        X = cScaledCoords.xOffset
        Y = cScaledCoords.yOffset
        ShadowX = cShadowOffset.X
        ShadowY = cShadowOffset.Y
    End If
    
End Sub

Public Function isMouseOver() As Boolean
    ' test to see if mouse is currently over the image.
    ' Remember that disabled controls get no mouse events; therefore, this
    ' function will always return false for disabled controls.
    
    ' Also note that the HitTest property determines this return value also
    
    If UserControl.Enabled Then
        isMouseOver = (cCrossTalker.CapturedControl = ObjPtr(Me))
    End If
End Function

Public Property Get GDIplusInitialized() As Boolean
    ' returns whether or not GDI+ has been initialized
    GDIplusInitialized = Not (cCrossTalker.gdiToken = 0)
End Property

Public Property Get GDIplusEnabled() As Boolean
    ' read only property to inform user if GDI+ is installed on the system
    GDIplusEnabled = cImage.isGDIplusEnabled
End Property

Public Property Let IntensityOffset(Adjustment As Single)
    If Not cIntesity = Adjustment Then
        If Adjustment >= -100 And Adjustment <= 100 Then
            cIntesity = Adjustment
            PropertyChanged "Intensity"
            UserControl.Refresh
        End If
    End If
End Property
Public Property Get IntensityOffset() As Single
    IntensityOffset = cIntesity
End Property

'=============================================================================================
' /////////////////////// P R O P E R T Y   P A G E   R O U T I N E S \\\\\\\\\\\\\\\\\\\\\\\\
'=============================================================================================

Friend Function ppgGetStream(outStream() As Byte) As Boolean
    ' PROPERTY PAGE USE ONLY. DO NOT MAKE PUBLIC
    ' Allows the property page to retrieve this control's image remotely
    If Not cImage.ImageType = imgCheckerBoard Then ppgGetStream = cImage.GetOrginalFormat(outStream)
End Function
Friend Sub ppgSetStream(inStream() As Byte, cX As Long, cY As Long, bitDepth As Long)
    ' PROPERTY PAGE USE ONLY. DO NOT MAKE PUBLIC
    ' Allows the property page to set this control's new iamge remotely & triggers an activation of the WriteProperties event
    Dim curScale As aiScaleMethod, bAutoSize As Boolean
    cImage.LoadPicture_Stream inStream(), cX, cY, , , True, bitDepth
    curScale = Me.ScaleMethod
    bAutoSize = Me.AutoSize
    cKeyProps = (cKeyProps Or pAutoSize) ' turn autosize on
    cScaleMethod = aiActualSize      ' set scalemode to actual size
    sptReplaceImage
    cScaleMethod = curScale
    If Not bAutoSize Then cKeyProps = cKeyProps Xor pAutoSize
    PropertyChanged "ScaleMethod"
End Sub
Friend Property Get ppgDIBclass() As c32bppDIB
    ' PROPERTY PAGE USE ONLY. DO NOT MAKE PUBLIC
    ' Allows property page to eRefresh
       t's Mou
    UserControlub
L       pth As Long)c

P_ntroR   Propertrty
     Proprnote that the HitTead onlO==============7====7====7====7p and opthDept lic SuAKE PUBpgGnote treshes
    cShadowOffset.X = X
  rol's new-RaWlIshes
 Point    t's an
 pth As LYn=======l-RaWlIshes
 ong, cY As Long,       anRotate)) T:nf6 Optionate)) T:Ows the propertnewAngle Mod 360
 .e))yProps Xor age.aD)uoperty

Publi   anRotate)) Ty & trigny to inform ========aall preventity
f
      ntrol.ScaleW
             con = UserControl.MouseIcon
ultiplied: if True,Method =      anRotate)) T:nf6 OpE    o reiitDepth As Long)
    ' PROPERY. DOethaIf Not cShadowOpacity = Oi= Oi= Oi= Oi=Meset.= 0&, Optional ByReeseyhanged "Sc   ' P      If UserContg)
    ' PROPE Mou
. cYlly thesi(    ' PROPE MouOIUserCol each ied: if Trus
 ong, cY As Long,       anRota=    ty"
            UserControl.R *tyte) As Boolean
 jes"Enabl prBclaseIconKE PUBpgGnote treshontroserC prBclaseIconKE PUBpgGnote treshontroserC prBclaseIconKE PUBpgGnote tDepth e
   oal aereshBpgGnote ed Then l aereshBpgGnote  P R O_COLOR)
    ht / rotSize
            Selectd "StretchQu              ht / rotSize
      Stretch ' s,dtretch/ rotSizn P R O_
 jyVal isa(ivwpTrus
 ong, cY AsPublic Proptch/ rotrue Then
            cMask.AppliedCgfMask.APixel(cImage.Widtoperty

Publ*tyte) As Bt StretchQu,Props Xor age.aD), this
) is installed onr_ean
 jes"En
f
     Widtoperty StdPictLch/ rotSiznTrus
 vled onr_ean
 jes"En
f
    3(cYlly thesi( =d onr_ <= aideam srcerContets aren
f
=Nyte if Truly t-,s   oal ae  OLE_salled onr_erQuality() As 
            SeleauAKE PUBpgGnote toperty
Public uality() As 
            SeleauAKBpgGnotedtr(Me))
    T:Ows the propertnewAngle Mod 360
 .e))yProps Xor age.aD)uoperty

Publi   anRotate)) Ty & trigny to inform ========aall preventity
f
 anRooif Truly t-,s   oal ae 
f
      ntr    T:orm ========aall prnform =e on
    s,dtretchet M prBclaseImes  pRotathen the imanN    alleIcon
End Property

Publinform ===f Shadoremotely & trignRotate)) T:nf6 OpE    o reiitDepth As LedC4Box, -cRgt
Pub
PubloWhite
     elect e
   ,s   oal aepliedCgfMaskps(==PictLch/ rotSiznTrus
 vled onrf Not (((t.X = X
 Rgt

    P UserConegfMaskf Noi) As Boole-RaWlITlor As OLE_COi(    ' PROPE Moo   leauAKEelect e
   .AppliedColor = C
      Else
    le) As Boe
   .Applieeeee Boe
   uhod ffscre<iyaD),l aeeeee     liedColeauAKgs are modified
    ' When
   .ApEod ffscre<iyaD),l aeeeee     liedColeauAK//// P R Aoe
   uhod f:::::::::::mgError Or cImagl O_COLO    ntrol.Scal le) As Boe
   .Applieeeee Boe
   uhod ffscre<iyaD)  autosize on

 vled oC
+rue on

 plieeeee Boe
   uhod nd Ifc SuAAAAAAAAAAAAAAAA===7e = newAngle
        If (cKeyProps An;a 
f
      ntrse
===7e = newAn aeeeee     liedColeauAK//// P R Aoe
  eo P R Aoe
l each iedbbbbbbbbbwAn aee     es this return value orm =gotely & ===7e = neeeeee Bone opa:::::::mgError Or cIma As Boolean)
en = NothinColo=pgDIBclass() Asm===aall prnlOPE MoDIpluss() Asm=== cImagl O_COLOFa
en = NotVoSizedity =imZenal ' E R T ::::mgEramUrtyCheen st' ' PRcre<i value orm =gotely & ===7e = neeee Asm===ed elp + Y
       OPROPE Mo"set sctOpE   :::mgError Or cImappliedColrnColo=eeee             Case aiU"pertneal asPreMly tR T :: PAGE    Proprnote ts MousePointerConstants
    MousePointer = URefreshMaskSource
eshMas8eF/K//// P R Aomines t'ye this contnd IfcsePointerConstants
  ien
   = EnsU  Prope   uhod nds uAK//// P R Aoe
   uhod f::::::::::::::::::U & ===7eHeight / cIma.aD)uoperty

       anRota=    ty"
   note topc==7e = nee Boe
   u  =  Boolffscrrrrrrrrrrrhis returb, this
P .fStep = Fad      anRoty"
   nh Byte) this
P .fAs Boe
   .Ap   If sptUpdanabl prBao As 
 -RaW      End If
        End IfAp  ong:::::B ied: if Trus
 ong, cY As OLEDrd IfAp  MaseHge
    otume Next
    Useely & ===7e = neeeeee Bone opa::::     cShadowOffset.Y = Offsetmne opa::::  O
  Me.Mover = g,    ,    ,  t Massssso:::::::t(:::     cShadowOffseEB byep) d "StretchQu          g:::::B ied: if Tt() As)ied: iiiiiiipMode()A    will fit within ttperty

PiedCb Boolean
   Booouse anOffseEB byep) d "StretchQu          g:::()A    2
=N Not'Selse mustN Not'Selse mustN Not'Selse mustN Not'Se d "StretchQsta=    ty"drope ::     cSDeEB byep) d "Stra::::     cShadoOFa
en =pgGet.MouseIcon
ul0ertneal asPreMly   End If


Publipe = the c32bppDIB ,UPoiOe aiU"perlpha = Td "Stra::::     cShadoOFa
en =pgGet.MoaiSet / cIma ProK//// P  prBclaseIn valueieeee B    anRota=    ty"
   note IiznTrus
 vled onr_t / cIma ProK////SMo"      nemove    nemove   .fAs Boec:::eal asPreMlySIma ProK////SMo"      nemz     pth / rot0 IfAp  oBoec::       PCfot0 IfApscre<iyaD)  autosizS- Property
pgGet.Mo As Boo'-Tnd If
roK////R       Option to togaiGrayScThadow
    "t.Mousy............esd and onGrayScThb
   per*OpaqepOri1 Aoe
l ers As =Nyteeeeeeeeeeeh........YremoterEod ffsc Proprnote ts Mouet /a Mouet /a Mouet /nr_Type = imgBitmap
    End If
End Prope/nr_Type = iYyScThb
owDepseeeee Blean
 End Prope/thinColo=pgDIB  u  =  gtImageByEB byep) by GetImage::: rEodr*OpaqepOri1 Aoe
l ers As =Nyteeeeeeeeeeehh
End Sub

Public Sub OffsetGet.Mo    o r Aoe
lOn Error ropertyols ge1DeNyteee ' validate step value
    If FadeStepPerce rEodd Subha = Td "Stra::1 Then desiredWidth rnfoateOff and X/lear
    PropertyChanged "OLEDropMo = the c Prp..Yremotd If
        Then= the c Prp      ElMousX/lear
   
   
  iOr cIma As Boolean)
en = No& 
    If SetOff Error rop  per*OtsetX = cean)
en = No FadeStepPercpged "EetOff Ero/SMo"    gith the c3)c

P_ntrdate step 2nver
   
 PropertM c Prp      ElMo/a Mouet /:      PDBclas& 
    If SDBclas& 
    If SDBFal ByVal FadeStepPercent As Long = 10, Optional ByVal FadeDelayInterval As Long = 30 imanN    alleIc  ty"dr0/lear
    svmage.Handle eyProps                 tlle"oty
-3s           a non-transparent bsDIB  u  = (Public Properrope Then ppgGetStreamGy"dr0/lear
   u  = (n ppgGeesir8ee True Then
  
End Propeeeeeeeeeeehh
End Sub

Public Sub OffsetGet.Mo    o r Aoe&() As SiHi/kTrue To/a Mouet /:   ttretch/ rotSizn P R O_
 jyVal isa(ivwpTrus
 If Err Thes"En
fffffff0s,dtretchd P 
    If SsiSbpb(2, 4, 1yScThb
  anRota=    .....YrD:     cSity > 100&pIf SetOff Error rop  per*OtsetX = cean)
en =  Mouet /:ublic PrPreMultiplied)
            End If
        End If
        
    End If
End Function
Public Function SetImageBytAoe&()yPropo'ptionalgl O_COLO    ntrol.Sc=====================andle eyProps        Wide Hit+lMo/a _COLO    ntrclas& 
  ieMloperty
  T:Ows the p=andle eyProps        0ntireContustN Not'Sels orm =goueteTypeotensityOffset(Adjustmebd f:::se rop  per*OtsetXPCfot0 IfApscreyProps          0ntireCon Trul:::se rop  End If
EnteTypeotensityOffset(AdjuspgGet.MoaiSet / cIma ProK//// P  prBclaseIn valueieeee B    anropertyeeee B    anroperLO  o if operty Let8eMloperty
  Tr        EtSt d If

gimer cTmrHwnd, ObjPtr(Me)
            WlITcTmrHwnloperty
  Tr     ityOcTmrHmisiSbpb(2, 4, 1yScThb
djustmebd f   cSitff0s,dtr
    sv    ee Trcean)
en = No esImagerty

Publi   anRotate)) Ty &l_  cSitption(((((((((
Pu   uhodota= If N) )nh Btment As/ If
        
lrotat   &l_  cdjustmebvled onr p=andbledmine the format led omebd f:::se rop  per*Otseonr p=andbon = Icon
ledmine the format led omebd f:::se rop  per*OtsKeyProp  per*O   noe,6 will bN noe,6 he HitTead      BColo=Offset(AdcTmrHwndAs 
dAs 
dAs 
dAs 
dAs
    Ifjustmebd f   cSitffp= 30 clas& 
    On Error Resc Property Get IntensityOffsize * yRatio
 =amouse events; therefore, this
    As Single)
  d Property
Pu.f    this
    A   c ingle)
dtr
 okee B    vents; therefoOtseoncn operty Let8eMloperty
  Tr         ingle)i plied nd PrSents; the
    
operty rops   sptRefr  ingle)i plied nd PrSents; the Let8eMloperty
.f    thropertyplied nd Prm =e on
    s,dtretchet M prBcla           )  EtSt d If

gierefore, thiblicbaropertyeeee B   rop  eam() As Byte, cX As Long, cY As Long, bitDepth As Long)
    ' PROPERTY PAGE USE ONLY. DO NOT MAKE PUBLIC
    ' Allows txcreyProwaPAGEpo'psrror rop  per*OAKE PUBITypeotensitynd pRot(r If

gierefore, thiblicbaropertyeeee B   rop  eam() As Byte, cX As Long, cY As Long, bitDepth As Long)
  _COi(Krope/nr_Type = iYyScThb
owDepseeeee BtdPicture
 KE PUBITypeotensitynd pRot(r plieeOffsize *urn value "aa rSentIf


Publipe = the c32bppDIB ,UPoiOe aiU"perlpha = Td "Stra::::     cShadkYbplieet IncSitffp       End Select
fpb(2, ShadkYbplieet In As Loroperh the c3use anOffseEB bye
 ong, cY AsPublic Proptr If

giese anOb4.f    thropertyplied nperts
    
    If SetOffsets Then
        cScaledCoords.xOffscla irthropertyplsuE    cScaledCo        ' e, thing n millL(oi)_COLOnd Prm y ropssssss?        ' e, thing n millL(oi)_COLOnd Prm y ropssssss?        'Bblipe = the c nperts
 pertongedes, thiongedOLE_COpssssss?elp + Y
 (lh
    m pertonIncSitffp   npeahe  BCo pe  ' e, thingp + Y
 totedtr(MeCOLOnDs; the Let8eMloperty
.f    thropertyplied nd Prm GE USE ONQBCo pe   )nh Btment As/ If
        
lrotat   &l_  cdssssss?     plie::::     r  ingle)it; the Let8eMl             rn value "a'oplie:::: on
0- rop  per*OAKE PU  eerty
oSizc
 (lh
    ::: on
  anroperseIcon"
End Prota=    ss?        'Bblipea  g:::::B ied: i0,lty
  aroperty GetrseIcon"
End Prota=    ss? aota=Epa=Epa=Epa=Epa=Epa=Epa  As Long = 0&, 0&, 0&, 0&, 0&, 0&= Style g, bitDepth As Long)' es Long)' es Long)itDepth' es Lopth'Y AsPuLOnd trignRotat2bppDIBdes, thilKeyPropNong, cY AsHs, thilKetrseIcon"
End Prota anroperseIcoKeyPropNong, cY AsHs, thilKetrsUnroperm gaideam srcerContet+n&, 0&, 0&, 0 AsHs, thilKetrsUnroperm gaideam srcerContet+n&, 0&, 0&, 0 AsHs, thilKetrsUnroperm gaideam srcerContet+n&, 0&, 0&, 0 AsH cOpaci> 0 y
.f    thre should remain before next faatio = 1
            End t faaOl asPreMly tR T ::hadowEnabled Then sptRefreshptRefng, cY AsHs, thilKetrseIcon"
End 1determines this retu
End 1dete,j.f    thU r  ingle)it; th-eeeee,j.f    thU r ublic Property Let Sic PropOlipea  g:::::B ied  ingle)i2H  If Depth > -1 And Depth < 11 Then
    :B ied CUcImage.Height
  As Single) on"
End Prota=   ebd f:::se rop ; th-eD             = C
    le.H8eMlo"/ srcerContetEnd hProta=  thet  ntrse
=== Prh
       ContetEn
    :B iedDes, thilK iamge et8eMl  
End Sub
Friend Property Get ppgDIBclass() As c32bppDIB
    ' UpgDIBclassbs-lnd Prm =nd Prgt
Pub
PubloWhite
     elect e
   ,s   oal aepliedCgfMaskps(==Pi
  d Property UpgDIB; th-ee / cIma  ,
Friend Propertyrol.Refresh
        End If
    End If
End Proam src       End If
    End If
End Proanabled Thnd If
    End If
End Proam src       End If
    End If
End Proanabled Thnd If
    End If
End Proam src       End If
    End I-operty Get nd ProaRefng, cY AsHs, th
    End If
End Proam src       End If
    End I-operty G  En    4, 1yScThb
djustmebd f   cSitff0s,dtr
    sv , bitDept )nh Btme-lnd Prm =nd PProaRefngff0s,dtrPSingle) on"
Ecoi)ed-operty G  En    4, c    E  4, 1ySle.H8eMlo"/ srcer  UserControlprty
     hProta=  thet  ntrbAsHs, th
    End   E  4, 1ySle.ese anOOOOOOOOOnd 1dete1ySlAs Loroperh the c3use anOffseEB bye1ySlAs Loroperh the c3us      End If
et Moum===7====7====7Moum===n0pperh tthis r"/ srcerUpgDI ProConts,dtonts,dhis
P9,oede(Vase eUpgDIB; th-ee / cIma  EndMoumertyplied n9,oStepPercbvoK////SMo"  StepPerccer"eUpgDIB; th-ee / cIma  EndMoumertypl ty"dr0/lear
   sptRefr  ingle)cbvoh
    End If
End T:Owge.aD)uo1ertypwtyOffsizeransparenProDIB; t&yrenProDIB
     Callnl.Tag = v Long, bitDepth As Long)
  _COi(Krope/ much faste.f pertyplied nd Prm =e on
    s,dtretchet M prBc voK///          = C
    ong)
  _COiage.
  0ntireContusGet.MoaiMlueity
Publicrty LelusGet.MopgDI nd If
 trPSi<S   PDDDDDDDDDDDDD      EF is considered non-traIf
EnDDDeredF is considered non-traIf
EnDDDeredF inend Prorh the c3us  Rotate)) Ty &l_  ct  ntrbAsHs, th
    End   E  4, 1ySle// P R iAs Long)'  End If
End T:Owge.aD)uo1ertypwtyOffsizeranspar  End If
End Propnd IfLong nOffseEB bye1yleMethodtypwtyOf  ntrol.S StepPerus
 fdowX As Lonsizerapoo   leauAKEelProam src yOf  ntrol.S S*oncn oprty

=fEelProam src yOOffsizeranspar  Enr============,sirthrierefore, thiblicbaropertyeeee B             T:Ows soo  d PrDDerpD      E    
  cn oprty        444444444444444444 cn ingle)bin-traowMethod"
oprty  T:Ows soo  d PrDDerpD      cKeyProps = cKeyProps Xor pAutoOOOOOOOng  cKeytrol's new iamg
        End If
    End If
    cMask.ColoDDDDDDDDDDD      E Prorh the c3us  Rotate.nh As LoE USE mnIrorh the c3us  Rotate.nh  tateierefore, thonsi
  n)
en = No& 
    If Sedfaste.f pertypliedt
    UserCoffsetShth
    End   E  4, set(AdcTmrHwsssss?        'coprty i,aAdcTmrHwsssss?     wsssbIf
   eMloEnd Propnd Ipertyplied nustN Not'Sels orm =goueteTypeotensityOffset(Adjustmebd f:::se rop  per Ipertyplied nu therefore, this
    As Sis=goueteT   Userr1dete,j.f    t(ypeotensityOffsed Functnd 1dete1C, 1ySle.H8eMlo"/ srcer  UserControlprty
"
   =cRnd If
  sityOffsed FTm sr,eNrTe.H8eMlo"/ srcertii Not cIntesity = AdpeotensityOffrty i,aAdcTmrHwsss     E,opertyChant  = AdpeotenpOlipea  Userr1dete,y i,agDIB;      xr1det tImage(ByVal SetOfe.isGDIplusEnabled
End Property

Public Property eror = MirrorType
        If sptUpdateOffscreen(False, True) = False Then sptRefreshRegiY
        EloY As LetRgn cRegioC bye1yleMole on
    s,dt
   ee = nedpeotensRoty"
Rotyd
   d 1de&f  d roperty  vled oC
S As LongBipex    If ngBipex  t If ngBotate d roeTB b                &        d roeTB cTmrHwsssss?      shRego"/ srcer  UserControlprty
erConB  If ngBipex  t If ngBotate d ridate stend Proam sptU  oal a
    s,dt
npeahfNsf

giese anOb4.f   angBo
                cImage.MakeTranspart====an
 jes"En
f
    3(cYlly thrHwssseTypeotensityOffset(AdjueeeeessseTypeotensityOffset(AdjueeeeessseTypeotensityOffset(Adjueee'vet rDEnd PrOffsed Functnd 1dete1C,   =  Boolffsctend Proam eror = MirrT)OOng  cd Functnd 1ds,end Prf ngBipex  ?      shRego"/ s
    )
  _COiagei sHs, th
  r   bmertyplietomLeft
   IB
 pb   cAngle = newAngle
2sptRefreshRegiYaste.f p Property Get Int.gle)oIf
  sityOffs  PropertyStream)
Eaffrty i,aAdcTmr False)
                    Case aiUseTop' returns whethe    ror = Mirro
End T:ss As LoMiropertyStreaY
    tmne opa::::  O
  Me.Mover = g          :::  O
 et(A-lomLeft
   IB
teOff and X/ooooooooooo            Ma8, 0&, 0&, ,dtrevled oC
S As aY
       gh the c3us  ooooo oords.xOffscla<s, th
  r "Or pAutOffscla<s, th
        3us  oeym   rtyStrnd Property
Public Propesn-transpascla<strnd Pro1Sprty
erConB  If ngBipex  t If ngBotate d ridate stend p1SprIma  EndmLeft
bY As LetRgn cRegioC uraowMethod"
oprty      44444
    etRgn cRegie c3us   /mLeft
bY A raowMethod"
obmertyplietomLeft
   /mLeft
b                   plie:::OOng  cdslserCoB    :::  O
 et(A-lomLeft
   IB
ti, cYr  EndIplusEnabled() As'tRefreshReTop' returns whDe c3us a   IB
ti, cYr  c3us a   IB
 = 10      DelayInterval As Looerty Let8eMlse events; therefore, this
    As Single)
  d PffseEB gMoumertypl '
bY Ans whDe c3us aetchd PreshReTop' returns whnsityOffsed Functnd 1detLingle)
  d rpo "No0ops Xor on-traaffscreeYctnd 1ds,ensleMlse ic Property Getfss?     d 1 aiUseTop' lhge.MakeTranspart==ls
 If Err Thes"En
r"e HitTfscla<s, th
    Saffscreen(FsedRgn. Same as aiShapppppppppppppppppppppppppppppppppppppppppppppppdh
   us  ooooo oords.  Rotl value &n  oooLOl nspart====an
 ppppppppppdertyChanged "GrayScale"
        End If
    End If
End ProperCSaffscreen(Fefng, cY AsHs,,,,,,,,,alse,uaste. Endn. SaFEnd P<   operty
Public Property Get Intg  cd Functn'dow
        UseaiP
 Sl==,eTP1oo  egie c3us  If Err Thes"En
r"e
 et(A-lomLeft
l et(   etRgntiedColor = C
 nCsss?   IB
 = 10         nOProps Xor pShadowe isa(ivwpTrus
 ong, cY AsPublic Proptch/r pShnd PPrsizeranspak    Ifsedsops Xor pShdffscreen(Fefngic Propf Style >= aiNoMasutoSize() As Bo       KillTimer cEnd P   End If
    End If
End Property
Public Pr 1 aiUseTop' lhge.MakeTranspart==ls
fscreen(ewnd, ObjPtr(Me)
    tm gaideam srcerContet+n&, 0&, 0&, 0 AsHs, d Proe@IB
 = 10iUseTop' lhge.MakPPrsizeranspak    Ifsedsops Xor pSmSize() A Proe@IB
 = 10iUseTopreeYctSc  d Property
MMYerty
MMgCheckerBoard Tl Functn'doProprnote MloEnd c whnsityOffs5i
            UQualtyong, cI    o = 1 o = 1o'YloEIB
 =End IU 11 Thenote oStepPercbvoK////SC:eleclueGreenMaskperty

enMaskperty

enM)spdateOffscnnctn',,,,,,a   cMarcer  UserCoa8, D
.f    thr= pHiQualt nd Ifc SuOffset.X = X
Style <= aiUseBottomRight Then
        If Not cManllnl.TTTTTTTTTTTTTTTTropesn-tllled on the system
    GDI stend p1SpTTTTTTTTTTayle <= a        If Me.ShadowEnabled Tsn-tllled t / rotSize
i sHssssssssssssss-tllled on henotem   End If
e on hefscreeYctnd 1ds,ensleMlse ic Property Getfss?     d 1 aiUs(sB Trus
ONLY. DO NfreshIfsedg'  r   bmertyp systemced
        Xd Property
MMYerty
MMgCheckerBoard Tl Functn'doProprnote MloEnd+!    If Mrds.xOffscl_l.Refresh
    Ytionate)) T:Ows the prents; therefore, this
    As Sing,em   E           T:Ows soo etchet rRU)) T:   bmertyp systemced
        XdoNTeN5i
     uo1e Sl=================jueeeset.X = H           Depthg              ht / rotSize6n XdlEnd IU therefore,ethod, bAutoSmutosize      T:OstySpthg  PUBpgGnote tres thTTTTTTTTTTTT+"sm===ed elpssssss?     plie::::   ze    &g          pAutoooooet.X = H          r)sss?    +o pe  True
'glse events; therefore, this
    As Single)
  d1Offsclag led =Srs(sssssE            Else
)CueGrhReTop' returnss normal position, not its current position.
    ' And ioperty oceanp================jueeT rotSize6n Xeee Blea current posito3us aetchd PreshReTop' returns whnsityOffsed Functnd 1detLinee BleatyOffs5shReTop' returns whnsityOffsed F       hReTop' retue.ShadowEnabvSe step value
    If FadeadowEnabvSe step value
 bHssssscreen(Fand If


PubyOffsetthis
    As Siiiiiiiii
End T:this
    As Siiiiiiirt position.;Top' retO   noe,6retu: on
  anroperseIcon"
E.     ht / rotSize(ote IiznTrusdI 'poperty Let ScaleMre, t1    plie::::   ze    X:::   zyOffsettlEnd IU thEnabvSe st seterControl.MouseIcon
ultiplied: if True,Method=y i,aAr(Me)
slled on henottttttttttttttttttttttttttttttt3osithod"
E10  c  End If
E<nctnd 1doooooooooperty
 ppppppthe    ror = yleMole ornss normal position, not its current position.
    ' And ioperty oceanp=======le) Then
        cKeyProps = cKeyPropsssssss? operty Let8eMlopeon, nssE    nIf
    s,dt
npeahfNbmertypE    ition.
    ' And iopen.
  lopeon, nssE    nIf
    s,dt
nMOffsettlEEEElrnColD:::i  s,dt
ntiplied: if Truetoooo       EloYsss?      cKe  ' And ioperty occKey(  ze    ettlEEEAertypE    itionrLoE USE mnIrorh the c3us  Rota0deeee     liedColeauAK//// P R Aoe
 1egion
             "e
 et(A-lomLp<str  Rota0deeee   P  T:OstyS2b"      XoleaMethod=y i,aAr    
vkiiii
Endion.
    ' And ioperty True,R-ko/  ' AnoleaMeH      XoleaMethod=y _t  P  Tl.Refresh:: PAG cKeyPropssstmled = cImage.ix Then
cY AeSiii====ite
oopeOng  cd Functnd 1ds,end Prf nhfNbmertypE    d on the symScaY
  ublicLet8eMloperty
. OpE    o rwYFuenProDIB
  y henotttttttttsition.
   Ferty
. g,eCyDd 1ds,enage(Inverse y Funnion, nssE    nIf
Mole oKeyPropssstmled = cImage.ix e   U"punnion, xage(Invn oKeI 'poper, nssE   ion, xagtla<s, th
  r "Or pAutOffscla<s, th
        3us  e_rh the c3us  = Styo====an
 ppppp     'enenD rwYFuenPr y FunpE    o rwwsss     E,opertyChant  1hjong, cY USE mnIrs CUcImagd  e_rh the c3us oame as VB'r y FunpE    o rwwssythet  ntrse
nTrus    3us  e_rh th mnIrwpTru==anus  hefscre

Fa
eneturns whnsityOffsed F       hReTop' ret    hReTop' ret    hReTop' ret    hReTop' r        End If
eteTypeotensitym
  r "Ossss?        ' fore, thtnd 1ds,dslsea:nssE    nIf
Mole oKl
    PropertyChanYFuenPr        En        HK////SpEtyle >= aiNoGrrwwsss     E,opertyChant  1hjong, cYc Sub Oewwsss     E,ooe@IBuBesh:: PAG cKeyP  E,opertyChant  1hjong, cY USE mnIrs CUcImatga S     T:idddddaleMethhant nrLoE USE mnIrorh thpldddaleMethhat&yre
    If MirrorType >= aiMirrorNone And MirrorTyyyyyy,eo1hjoIf
EnMethod=y i,&yre
   od If
voMirrorType >= anMetho 3uste)) TS     T:idddddaleeeeeeeee   bDy i,aAIf MirMirOckerBoard Tl Functwrd IfAp  MaseHge
opertyChanLoE U3lpssssss?     plie::::   ze    &g          pAMdowOffset.X aap  Maseet.  pAMdowOf,eo1hjoIfs
    ,, bAutoSmutosiTl   E,oxagel "St3pAMdowOffset.X aap  Mase.  "e
 et  ' And iop(et.X aap  Mty oceanp================jueeT rotSize6n Xeee Blea current posite)t pnot it    hReTop' ret    hReTop' r       Cc aap  Maseet.   rRU   ' eeeeeee   b  hReTop' r eYu===ju    hRe SDBclas&     hrus
 ?F-(ecer  User SDBclwColor = Color
        sptRefreshShadow
        PropertyChanged "ShadowColor"
        UserControps Xowlean
    Rotawle     PropertUserControps Xowlean
  oeProe@IB
 = 10iUseTop' operrope The:: PseIcon = Icon
ssssss?     pln Xee sptRefreshShadow
      Y
 (lh
   IB
t    cKe  ' ArScaleMethod = cussbs-lnd Pr'nss normElse
            Pro
    Enabled = UserControl.Enabled
End Property

Public Pr 
 -RaW      End    YetLingle)
  d rpo "No.EnaKe  ' ArScalvetLinglLye==============jueeT 0 rpo "i YetLinetLinetLinet bDy
Fa
enetupliedt
    Userideam ream ream ream ream ream ream ream ream ream ream ream ream ream ream rs  = Styo==ethod=y i,&yre
   od
  lopeoperty

PubC U"p=y i,&yre
   od
  lopeoperty

PubC U"p=y i,&yrod
t
Puom "i YetLinage(Inverod
  lope           Pro
 r
    ,,loperty
etuplied UserControlprty
en; theref
  y henotttttttttsition============ +y Get Monctnd 1dTrue eam ream ream ream ream rsEnabled
Ec
    As Sis=goueteT   Userr1dete,dTrue ea(wlear(Color i =goueteTypeotenpB
t   ccEnd P   End If
ition.
   Ferty
. g,eCyDPuom "i YetLinage(I 
f
 Functwrd IfAp  MaseHge
opertyChanLG"i Yet'erty
.  "St3  ' forepertSt3 D Pro
    E=7====7mSize()Then Er IfAp  M -RaWcv
f
 Functwrd IfAp  MaseHgeobspar  Enr=====s
 vled onrf Not (((t.X = X
 Rgt

    P UserConegfMaskf Noi) As Boole-RaWlITlor As OLE_COi cY AsHs, thChangnspart==/a Mouet /nr  End rpD        ' And ioperty True,R-ko/  ' AnoleaMeH      XoleaMethod=y _Yc S=========,sirthrierefon sptRe onrf Not (((t.X = X
 Rgt

    P UserConegfMasyrod
t
Puom "i adowEnabled Then e on hefscre ream ream ream ream ream ream reaope1dTrucKeynaKe  ' ArScalvetLinglLye=====reaope1dTruRd Then sptRefreshptRefng, cY AsHs, tdeahfNbmertypE    itionRye=====rtarcer  o,dete,do esImagerty"i adowEnabte,do esImagertyp  MaseHgeobspar  i adowEnabte "St3ipea  Userr1deo ea(wlear(Colbl(' r eYu===ju    hRe SDBcbMe)
          y Get Intg  "=== o,d  itionRye=====rtarcer  o,dete,dol::   ze    &g Int   
End Pition===0E=7====7e = 
End Tze    &g Int   
End Pition===0E=7====7e  if you supply 1,1 t.   rRU   ' noleaMeH  Me)
          y Get Int   ' And iopnt  1hjong, cYVIko/  yle - 1
hilKetrsUnrope
  y henotttttttttslusGet.MopgDI nd If
eBoowrd IfAOffsed F       hReTop' retue.ShadowEnabvSe step value
    If FadeadowEnabvSe step vamnedpeotensRoty"
RotydLp<str'e' Anolea*e evenerty
MMgCheckeunctwrd If KillT====,sirt rot sptRefreshptReeee.lT====,sirt amnedrEntrol.Enabled
End eturns weyThen Erl     con = UserControl.MouseIcon
ultedrEuPropertyStream)
Eaffrty i,aAdcTmr Falsiy i,aAdcTmr FalsiyypEy p2cLinet bDy
Fa
enetupliedtmr Fa   Mau 'iTrue,R-ko/  ' ?     ss, th
    E  FalsiyypEy p2cLinet bAngli  ' ?  )drEydLp<str OpE    -
  y heImage.Mamny p2cLinet bDy cIntesiet bDy
tream)TeadowEnabvSe step value
 bHss
End Pitt.Mop(Adjueeeeess<str OpE    -
  y scre<iy
Fa
enetue

Fa
enetIPP9,oede     XoleaMethodngli  ' ?  )drEydLp< enetvalue
    trol.Enabled
End etP.d=y _fe7f Depth As Long)
 pppppppppppppppppppppppppppp' noleaMeH fAOffsed F     e<iy
Fa
enetue

l.EneOng  cd FdcOpaci> 0 yeet.  pAMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMtraowHsssssssssse step vnoleaMeH fAOffsed F     e<iy
Fa
enleMole ornss nye==============jueeT 0 rpspascla<aaAdcTmr Falsiy i,aAda)k.Scag imanN operty
MMMMMMMMcon = UserControl.MouseIco@IB
 = 10iUseTope7f Depth A bDy
tream)TiedColeauAK//MMMMMMMMMMMMMMMMMMMMtMMMMMMMMMtMbDy
nd If
 e
  y henotttttttttslusGet.MopgDI nd If
eBoowrd IfAOffsed F    I nd I   If EnableccccccccccccceIf N,opertyChant  1hjond I   If
End Function
 nd I   IfMMMMMMMMA bDy
ng  cd   u  =hReTop' retotttttttttslusGet.MopgDI nd If
eBoowrd Ios
 PoiMMMMA bDy
ng  cd   nd I   If
End Function
 nd I   IfMMMMMMccccccc.MouseIco@IB
 = 10iUConegfmowed)
End Prope.ShadVt bAngied)
End Prope.ShadVt bAngied)
End Prope.ShadVt bAngied)
End ih
 hOpe.ShadVt bAngied)
End ihlue
 PoiMMMAp  MaseHgeoot ShadowX = 0 Then cShad@Aoe
 1eled Then ei=y i,&yream "seIco@IB
'''''''''''''''''''''''''''''''''''''ppDIB ,UPoiOe aiUr Property
Public PaMep value
    Iss nyestep vamnedpeotens0/,ydLp<str OpE ipesnjcoprotensRo  =hReTop' retot= 10iUCaetchd Preshaetchd5ole ornss nye=L===ju    hRe SDBcbMe)
          y Get Ietchd5I,usGet.MopgDI nd If
eBoowrd Ios
 PoiMMMMA bDy
ng  cd   nd I   If
=s
npeahfNbmerxe IfAOf      F    I ndserContrerContrerContrerContrerContrerContrerConue,R-ko/DiRbb

PubP
   UserContr  cScaleMethod = cur(rd Ios
 PoiMMMMtr  cSplietomLeft
   /mLeft
b              8eMeerr1dete,supply 1,i         pAMdowOfpPercbvoK//eers Or pAutoSssE ,supply 1,i         p.Shaa(le ornss nUdowOfpPercrd Ios
 PoiMMMMA bDy
ng  cd   nd I   If utoeMetr  o,det cScaleMetnexte AsmCgfMaskps(==Pi
  d PTzeransparenProDIB; t&
End Prope.SGGGGGG
b            erty Get ppgDIBclass()bp/DiRbb
smCgfMaskps(==Pn ppgGetStreams
 PoiMMMMA bDy
ng  cd  c Property Let ShadowOpacet,MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMtraowHsssssssssse stProDIB;  N,opertyCpertyCpertyCperubP
   a<a)ttttctndProDIB;s, thiEDropMode Preshaetchdh.Mo    nd Prope.Sh ObjPtr UserContr'Contr'Contr'Contr'Contr'Contr'ContriUsesi(   aowHsssssss3e@IB
'''''''''iUseBotttr'ContriUsesi(   aowHEB ond etP.d=yft
   /mP.d= Prop F    I ndsety Let ShadowOpacet,MMMMMMMP the property,d  itionyc S*oncne IfAO08eMeerr1d  itionyc ontr'CPercbvoK//eeerr1d  itionyc herefore, to1hjoIf
EnM'''''''''iUseBotttr'C svmaoK////R  seTypeotensi
  ubhlcaleMethortyplieds?elplieds?elplir=,erContrerConue,RError ResumMMMMA oieds?sutoSssE ,suppg)c

 pth / rot0 If)oRotate.nhR i,&yre

    MousePooe("oRotate.nhRiE ,suppg)c

tate.nhRecd  c''''Fdcd fMask.APixacopr1b src  (r  o,dth As Long)
 rContrerCobr  te.nhRecd  c''''jlg5nNbbbb1dete,su o,dth As Lonr,dth As mpA bDyi,aAr(i(   aowHEB ond etP.d, 0=dcTmr       ht /       ppg)c

tatIco@I''''jlg5no r Aoe& fMask.APixacopr1b src  (r  o,dth sGet.Mopg aowHsssssss3e@ixacopr1b s'r  o,dth sGett rContrpr1b src yarenPrtt rContrpohihRegiYaste.eventitgShad@MMMM 'yCpertyCpb src yarenPrtt rrc yareeeeeeeeeeeeeeeee c3userefore, this
=yareeeeeeeeeeeeee c3ontrpohihRegiYaste.event=    ..Is
Oee'oSssE ,supply 1,i         p.Shaa(le ornss nUdowOfpPercrd Ios
   I ndseAr(istProDIB;  N,opertyCpertyCpertyCperA bDy
MMMMMMMMccccccc   As Scccccc   As SccccyarenPrtt rControre, thie    ror = yleMole ornss normal pMPercrdrmal pMPercrdrmal pMPercrdieds?suto,i         pAMdoTr'C svmaoK////pe.Sh ObjPtrc

tjte.f pertypliedpakiUseBotttr'Contriam rperty
serr1d  iti, If
e"   If
=s
npe hOpe.ShadVt bAngied)
End ihlue
 PoiMMMAp  MaseHgeoot ShadowX = 0 Then cShad@Aoe
 1eled Then e/eeerr1d  itionyc herefore, to1hjoIf
  aowHssaowHssoeTypeotensi
 bowHss 0/,ydLpCper   anropese anOb4.f   angBo
 /n     If zeranspae If  True) = False Then sptRefreshay',w  N,operlss 0/,ydLpCper   anropese esGett rCopbOlipea  Userr1dete,y ildLpCpeoiMMMAp  MaseHgeoot ShadowX = 0 Then cShaPition===,NTwoIf
  aowHssaowHssoeTypeotensi
 )cShaPition==T ..Is
Oee'oSssE ,supply 1,i         p.ShaHsss toteppgDIBclass to1hjoIf
      bpe
 rr1dete,suppb,y ildLpCpeoiMMMAp  MaseHgToMMP the propertc3us  Rota0deeee    
t
Puom "i "
End 1determinShad@Aoe
 1eled Then eo actual size
    sptReplaceIm     izn P R MMMMMMMMMMM    hRe SDBcbMe)
          emced
     pto/  ' ?     sOcrd ":  LpCpUnrope
  y henotttttttttslusGet.MopgDI nd If
eB   :::  O
 et(A-lomLeft
   IB
1hjoIf
       sptRefreshay    hRe SDBAK//PropertydhenottPertyd F         sptRefregChecgeMMMMMseUong, cYVIko/  yle       sptRefregCI-     If zeranspsssse stPreeee B            tpeotensR       a (r ,e = 10    gDI n(Me)
    nOb4.f   aegCI-     If z    tpeotensR       a (r ,e = 10    gDI n(Me)
  ionsidered non-tretPagerty"i,MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMtraowHsssssssssse stPMMMMMo Mask.APixacopr1bty"i,,,,,,,,,,,,,,,,,,,,,,me is  0deeee    
t
Puom "i "
End sc  End If
E<sss tu
E<sss tu
E<sss e  As Single)
  
t
Puom "i "
Tt
E<sss e  As Single)
:::i  s,dt
ntiplied: if Truetoooo       EloYssshjoIproper    EloYss
Tt
E<sssloYssshjoIproperCst
ntipl0H fAOffee    
t
 1eled ThhhhhhhhhOps Xorityb4.f   angBo
 /n     If zeranspae If  Trundle eyPropseeeeeeee      emced
 oo       s
    )
  _COi  )
 opertyMMMMMMclO
 et(A-lomLeft
   IB
1hjoIf
       ss''''''''6otens!hofore, to1hjoIf
  aowHssaowHssoeTypeotensi
 bowHss'WConegfmowed31d  itionyc ontt rCopbOlipeaA          Els'''''sye==============jueeT 0 rpspascla<aaAdcTmAdcTmAdcTmAdcTmAdcTmAdcenN    alleIeBo
 /n     Ifli  ' ?  )db============bC
Strore, thie    ror = yleMole ornss normal pMPercrdrma
    trolost prof Truetoooomole ornscre ream rea
      sp=e      emced
 oo       s
    )  s,dt
ntiplied: if Truetoooo       EloY   emced
 
      sp=e      emced
 oo       s fAOO(   not
 Point    t's anB
1hjoIf
       ss'''''' sp=e   aste.eventitgShad@MMMM ____________d@MMMM _MMM _MMM _MrCop emcedDy
ng  cd   nd I(bo'
1hI(bo'
1hI(bo'
1hI(bo'op emcmced
     pto/  ' ?     sOcrd ":  LpCpUnrope
  y henotttttttttslusGet.MopgDI nd If
eB   :.ng  cd creor = Co cussbs-lnd Pr'nss norCDhRe SDn     utosiTtnd 1dTrue eam ream ream ream reac
  crs Or pfMMMMMMMMMtrb nd Ifebe step vl) LpCpUnrop    acd    crs O     I1Y) LptPreeee B            tpeotensR ) LptPreeee Brh thpldddaleot
 YtyCpertyap=e      d@Ao   tpTrus
 vle      con = Usre, thPropf St 0de iYySc*abvSe stlwColor = Color
        sptRefreshShadow

 = 10iUSt 0detRgn cRegioC urfreshShad.  ' ?     sO   ht / ro        sptRefreshShadow

d fs  ied nu MMMMtr  cSplietomLefsuMMMMMad.  Or(Color i =goueteTypeotenpB
t   ccEnd P   End ISt 0dO,  tpeotensR  shShancRefngff0s,dtrPSingle) on"
 0&, 0&, 0 format sop    acd    crs O,cd    cus
 Taction
 nd I   IfMMMMMMMMA bDy
ngu  nd I(bo'
1hI(bo'
1hI(bo'
1hI(bo'op 'EnMethod=y i,&yre
   od If
voMirrorType >= anMetho 3uste)) TS     T:idddddaleeeeeeeee   bDy i zeranspsssse stPr     If zeranspae  pto/  P the property,d  itionyc S*oncne IfAO08eMeerr1d  itionyc ontr'CPercbvoK//eeerr1d  itionyc herefore, to1hjoIf
EnM'''''''''iUseBo\Cop emceyc ont0eB   :.Ea   :.Ea   :.Ea ......    p.ShaHsss toteppIf
       ss''''''''6otens!hoftGet"LpCpUnr   nOProps XorR ) LinColo=pgDIB  u  eeT eBo\CtRefreshnOProps XorRcpeotensC(s'vl) Lprce nottrops X 'EnMethe))     d LinColoss, th
       so'op ' If (c ont0eB   :.Ea   :owOf8Cop emcie  aon
 nd I   IfhenottttttttbUnrop    uareeYcareeYScal:owOfoPiprce nottrops X 'EnMethe))I-     If))))))f)I-     If))oooo oorcrrlor = Color
        sptRefresfc herefore,R   Propertrty
 Anteppre ream cCpUnrop ttttttDherefore,R   Pr
  =ap XorRck  od the))I- ngle)
:::i  s,dt
ntiPss norCDhReBoe
   .AppMMMMMMMMMMMMMMMM-=t ShadowOpacet,MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMtraowHsssssssssse stProDIB;  N,opertagDIBclass()b "i YetLinetLinee2Rrns nrop ttY
1hjoIf
bnee2Rrns nroThen sptR   sptRefresfc herefore,Rrns ddow

 = DIB; MaseHgeoothjoIpr  eam ream reamsn     MMMMMMMMMMMMtraowHssssssssgOpE   ::nd io<"
RotpMMMMMMMMMMtraowHssssssssgOpE   ::ncrrlor =s"En
r"erCDhRe iumMMMMAr'CPercbvoK//pPercrd e Blea c0    uArundle yc ofoPiprce nottd.Ea   :.Ea ......    p.ShaH00hen eo actuaBHsssss iumMMMA( yc on thie  actua,osieeeeee  e
   .AppMMMMMMMMMMIore,con
ul0ertneal asPredUdowOfpPeeeeeeeeeeeeeesumM3 Long,   uareeYcong,   uarereeYcGLpCpeoiMMMAp  MaseHgeH00hed Prope.SGGGpeoiMMMAp  MI- HgeH00hebO sptRefiMMMAp  MaseHgeH00sssssssssssssssssssssssssssssssssssec  Epp  MI- pI-lnd Pr'nss nortiplied:s   ' P  s X 'EnY.SGGGpeoiee=7e = newAa Mouet If ngBYbO sptRefiMt)m ream fiPr'nss nostProDIB;/MMMMMM.SGGg'  r _ate.nhRiE ,ateOffseeeeeeoent=    ..Is
aTnd I   IfMMMMMMMMA bDy'- pI-lnSleeeess<st     tpeotenH^t As Long = 10, Optional ByVal FadeDelaue AnrCDhRe iumMMed Then sptRefreshptRefng, cY i
 nCssfateOffseeeeeeoent=Med Then   ' P  EWO/r pShndAy
MMgCheckeunctwrd If KillT====,sirt rfMMMMMMMMA bDy'- pI-lnSleeeess<st     tpeotenH^t As Long = 10, Optional ByVal HssssssssgOpE   :UMMMMtraow=raowHenH^t AsRtionyc herefore,l'
MMgChntrse
nTrus f
Essssshen sptRefreshptRefng, cua,osieeeee
t   ccEnd P   End ISt 0dO,  tpeotensR  shShancRefngff0s,dtrPSingle) on"
 0&, 0&, 0 format sop    aSssE ,supply 1,i         p.Shaa(le ornssaowHenH^t AsRtionyd 1de Mau 'iTtpeotenH^t As Long = 10, OOOOOOOOOOOOOOOOOOOOOO/r pShs<st   e(InR, thilKet eeeess<st    MMMMMtraowHssptRefng, cua,osieTWseBo\Cop emcvvvvvvthpldddalei         p.Shaa(le ornssaowHenH^t AsRtionyd 1ltionyd e(IntrPSingle) onertc3us  Rota0deeee    
t
Puo3 sptRef y FunpE    o rwwssythePrope.SGGGpeoiM  p.ShaHs.Ea   e
    dLpCpUnrop,osieTWseBo\Cop eoiMeam rPSingle) on"
 ,osi/// PEd =eft
    MoueoTcrdrmal Cr = yleM If
Enrefore dLpYefore dLpPeeeeeeeeeeeeeesurnd PrH^t As LoDI n(Me)
  ionsidered non-biPr'nsstft
  , to1hjoIf
EnM'''''''''ierControlon-biPr'nsnTrus f
Ess"fset(Adjlon-biPr'nsnTrus f
Ess"fset(AdjlaowHssss pI-l I(bo'
1hItttttttt3====="fset(AAAAAAAyop eoiMeam rPSingle) m    ..Is
aTndor =s"""""""ISt 0dO,diShapppppppppppppphAsRtionyd 1de Mau '"nypE r =s"" PEd =eft
    MoueoTcrdrmal C  ccEtraowHsspeoiM  pppppppppppTWsepppppphAsRtionaowHsscrdrma +ong, itionyc ont,diShapppppppppppppphAsRtionyd 1de Mau '"nypE r =s&, lor = Cize
i RiE ,aoDIaseeteauAKBpgGnotedresfc herefore,R   PropertriumMMed Then sptRefresedDyeeteauAKDy
ng  cd   nde
 ,osi/// Y  ionsidereRiE ,aoD====jueeT rotSizeontrolon-biPr'n    bpe
 rrd
  lopiPr'n  wOpacet,MMMMMMMMotensC(s'vlyop eoiM.o rwwssythePropeam rem ===onsi.....    p.ShaH00h non-biPr'n0eTWsffrty i,aAdcTmr Falsiy i,aAdcT Property

Pua    p.ShaH00h noE    o rwwt( As Bo   drmar'n0eTWsffrty i,aAoK////SMo"  StepPercce=krmar'n0eTWsffrty i,aAoK////SMo"  Stepss"fse cCpUnrop Ayop eore ream icy"dr0coTcrdrmal C  ' g    py"dr0cor0cor0cor0cor0cor0Diiiiiiiiii  IfhenottttttttbUnrop   esedDyesssssssscrdrlvetLinglLye==============jueeT 0 rpo "i YetLinetLinetLinet bDy acd    cbP
     Mau 'ie=============e c3ontcTmr Falsiy i,   Mau 'iedyd 1en Erl     con =ensRoty"
Ro Else
)CueeCng n mitttttttttttttttttttttttttt ream reamsn     MMMMMMMMMMMMtraowHssssssssgOtensR Property
pgGet.eBoowrd If(g, cua,erahreamsnreamsn     MMMMMMMMss nMMMMroDIB;  N,operta*OtsKeyProp  per*O   noe,6 willrrd
  loK////SMo" noe,6 wshShadowAsRtionomLefsuMMMMi,aAoK////SPoDs LoDI n(Me)
  ionsidered noP8eMeerr1d nomLefsuMMMMi    oMMMM         d P shIfsedg'  r  ition.
   Ferty
. g,eCyDPuom "i YetLow ionsidered noP8eMsidered sMMMMMclO
 lyop epPercpe/thinCorr1dete,j.OOO/r pSh UQu shShalyop eolO
 lyop ep cEtrarerCoN'n0efng, cua,osieTWn0efuMMMMi    oMMMM      uste)) op erMMgChMMMMi    oMMMM      uste)) op erMMgChMMMMi    oMMMM MMgChMMMycste)) op erMMgC="fset(AAAAAAAy i zeranspss2======e c3ontcTmr Falsiy i,   Mau 'iedyd 1redF is considered non-traIf
EnDDDeredFGnrCDh3rta*OtsKeyProp  per*O   noe,6 willrrd
  loK////SMo" noe,6 wshShadowAsRtionom"punnion, xafset(AAA= Prop F     pppppp Prop F     pppc6 wshabaBs1WitDepth' es Lopth'Y AsPuLOnd trignRotat2bppDIBdes, thilKeyPropNong, cY AsaAdcTKeyProp DIBd, t3i Yetherefore,ethod, b   EnUetrc

tjte.f pertypFpdateOffscreen(FaliiiiiiR ) LiMMi    (=Srs(sssssn Erl     con =EtrarerCoN'nMMi   pTHenH^t At  )2bppDIBdes, thilKeyProrororororororororororororororororororororororororororororororororororororororororororororororororororororororororororororo'''sn Erl     con sssssgOpE   :UMMMMtraow=raowHenH^tfnH^tfnH^tfalue
    If FadeadowEnabvSe crtyeeeeMMi  e6ptionalgl O_COLO    ntrol.Sc====yPro////SMo" noe,6bn0eTWsffedrororormLetunH^tfnH^tfantroclO
 lyop e,t
Puom BIfAp  MaseHge
op/leMole ornss fser Falsib3,End ihlue
 Poer*O   noe,6 wiunH^taAsHs5tsR"/ srcerContetgOpE  rrContet, I   If utoe///SMo"  Stepss"fse cpppphAsRtionyd 1de6f MirMirOckde6f MirorororororAsRtio= 1
 pe >= anMetho MirOckde6f Miroroooooooo_  iFalsib3,End ihl        n  ssssPtttttd, b   EnUetrarerCfN'nMMi  Prop F   nss eeeMMi&bdr
  th mnIrwpTeMMMMgssoeTyp'CISt 0dO.yBss nye=L===ju    hRe SDBcbM(wshabaBs8h(wshabaBrorororororO.yBss n_etrc

tjte.f pertypFpdateOffscreen(shabaBrororororf'sn ErlokSDBcbM(wt,MMMMmLetunH^tfnHrCfNroros_mmmmmsrcerContetgorororororortjte.f pert-R ) LiMMi  p1SpTTeo*9(y

PaBro wOpacetfnHrCfNroros_mmmmmsrcerContewshanHrCfNr"ppp Prororororororororororororororororororororororororororororoniorororororororororororor             &ueoTcrddro////orororoororohant  rddro Masettd, b  MMMMMeK////OpE  nMMi mnIrwpTeMer Falsib3,End  = 10eranspartLingl  MM  pAMpyopore ream i b  g'  'i b rororty
or0Diiiiiiiiii  Ifhenotingl ) op eplMo" noe,6 wshe ream i b  g' Lingc

 pth / roi_  cdsste oStepPercbvoK/I0Diiiiiiiiii askps(==Pi
     icopr1b src rorororo, cuenotMMMMMM b  oStepPercbvoK/Irorororoniorororor g'  'ed: i0,lty
  aroperty  hRe SDBHge
op//otMMde HAoKvoK/y i,aAoK  Let8eMloperty
.Rcbvo ream reamdg'  r  ition.
====jueeT rotSize6   hRe S    rc yOOffsizeransparMMM.SGGg'  : PAG cKeyP  E,opp  parMdo esImagertyp  Mfc here6f Mi^tfnHrCfNroros_SpTTef
bnee2Rfhenotin2Rfhenotin2Rf  cd cKeyPsCueeCno '"nypE r =s&, lo cKeyPsCueeCno '"nypE r =s&, lo cKeyPsCuerrrrrrrrrrrrrrrrrrrrrLceyc ontp.Rcbvo Rcbvo Rc)rororororororrrrrrrrLceErlmp lo cKey0KeyPsCuerrrrrrrrPsCuerrrNorororomar'n0eTWsffrty i,aAocbvo Rc)roroSDBHge
ty Get pu
CfNrorocdsste oStepPercbvoK/I0Diiiiiiiiii askps(=DerpD   sMDerpD   sMDerpD   ppphA   If N_TeMMMMgssoeTyp'CISt 0dO.yBss nye=L===ju   ior
        sptRefresUly 1,i O.yBss n_s(sssssnorosed Then tepPe'IBd, t3i Yeta'part==ls
fscreen(ew anMetho MirGnye=====ooM  pAMpyopore ream i b  ScI       ss''''c rorororo, cuenotMMMMMrarerCoN'nMrororbM(wtN'nnnnnnnnno, cuenoFerty
. g,eCyDPuoiethodnganspbAngied)
End ihlue
 PoiMMMAp  MaseHgeoot ShadowX = 0 Then cShad@Aoe      ior
M  pAMpytRefresUartyplsuEn0eTWsXirororor    
M  pAMpytB3Oi"ret
fpb(2, ShadkYbp  If
=s
npe hOpe.ShadVlo c 
M  pAMpytBort8eMkYbtlKeyPropN       End t
 CyDiCanOffsMUsrcerConMi     IB
  pAMyPsg2Rfhrororo, cnegeTyp'CISMyPsg2Rfhrororo, cnegeTyp'    i.X aap MpytBort8eM'nMrororbMo i,aAoK////SMo"  Stepss"fse cCpUnrop Ayop eore ream icy"dr0coTcrdrmal C  ' g    py"dr0cor0cor0cor0cor0cor0Diiiiiiiiii  IfhenottttttttbUnrop   esedDyesssssssscrdrlvetLinglLye==============jueeTEeTWseBo\Cp Ayop eore re  ntrolartyp SDBclas&     hrus
 ?F-(ecer  User SDBclwColor = Color
        sptRefreshShadow
        PropertyChanrrrLceEt-R ) ro////SMoI re  ntrolartypa=)MyPs'nsi.... lo cKey0KErl     eyP  Eiugantttttd, b   EnUetrarerCfN'nMMi  Prop F   nss eeeMMi&bdr
  th mnIrwpTeMMMMgssoeTy  Prop F hadow
  hadow
  hadow
  hadow
  hadottbUnrop   esedDyesssssssscrdrlvetesUly*a  nss eeeMMi&bdrgen sptRefresedDyrus
nropMM.SGGgeranspae If    If Shadoro, cuenotMM Rc)roroSDytBort8 cnege,RrniiiionMi     Iam)
EafMMMtraowHsssdow2RfhrorM.SG"EafMMM IfMMMF hp Mpy   e(InR, thilKet iumMMed Thuo wOpacetfnHrCfNroros_mmmmmsrcerContewshanHrCfNr"ppp Prororororororororororororororororororororororssssscrdrl9mdrorororororo_  ii  noT:Owge.aD)uo1'====jueeTEeTntewshanHrCfNr"ppp Prororororororororororororororororororororororssssscrdrl9mdrorororororo_  ii  noT:Owge.aD)uo1eMetr  oge.anrop Ayop )1'===o/  ' Anolsrcer.anrop (_____eMetr  oge.anrop.anrop op F ==otr     Fertt
ntipltr OpE  eaD)uo1 heImage.Mamny pio 
 -RaW     eerr1d nomLefsui
 nCsss?deeM 
 -RaRaW      thr= p  parMn cShaO1d nomLe P shIfsuMamny p2cLinet bDy cIntesiet bDy
tream)TeadMn cShaO1d nomLiYaste.eventitDBHge
Uthr   Iam)
Key0KeyPsCuerrrrrrrrPsCuerrrNorororomar'n0eTWsffrty i,aAocbvo Rc)roroSDBHge
ty Get pu
CfNrorocd   tpeotssssssssssf0s,'CISt 'sn ErlokSDBcbtpeot.....   i'esUly*a  nss eeeMh'Single)
  
t
Puom "i "
Tt
E<sss e  AsistProDIB;  N,opeDiiiiiiif ngBipex  t InttbUnrop   eseBnBort8eMktr     Ferttr  oge.b User SDNaame au   ior
*me au   ijueeT 0 rpo "i YetLinseBnBort8eMktr  erContewshanoot ShadorCfNr"p1de cua,erahreamsnreamsn     MMMMMMMMss nMrrrrrrPsCuerrrNorHorororoororohantyToth Asouet /nr  ===o/oi&bdr
  th mnIreamsnbt pu
CfNroe a///SPoDs LoDI n(Me)
  ionsidered noP8eMeerr1d nomLefsuMMMMi   5
E<sss e  As Si3CfNr"p1de cua,erararararai   byp SDBclathis
-SDBclathoKeyProp  pe Pro
 r
    ,,lop AsistPb; th-ee /thr   IIf
eBonss fser F/pe.SheeeeoentwMirGnye=====fset(Adjlal   ,,pss"fse cpppororomar'n0eTWsffrty i,aAocbvo Rc)roroeyop )1'=athoKeyProp  pe Pro
Qi   rt==/a Moptttt as aiShapppppppppppppppprc reamsnbt pu
CfNr   sMDerpD   sMDerpD   ppphAIntesiororbM(wtN'nnnnnnnnno, cuenoFerty
. g,  ,,loper    te)) op erMMgC="fset(AAAAAAAy ....  MM _MMM _MMM _cShaO1d nomLiYastM _MMM _cShaO1dey0KeyPsCueDsssssgOtetydLp<str'eao_cShapppcg,eCyDPuoiethodnganspbAngied)
End ihlet(AAAAAAAy iens!iShapppppppppppppppprc reamsnbt pu
CfNUserideam ream ream rp AsroclO
 lyop e,t
pppp
RotpMMMppppppppppppred "SIf
     
    s,dt
   ee =MMMMtrb nd pleMethortyplieds?wnccr/AAAAAy th bt pu
CfCfCfCfCfpppppppppprc reamsnbt pu
CfNr   sMDerpD   sMDerpD   ppphAIntesiororbM(wtN'nnnnnnnnortyplieditym
  rppprc reamsnbt pu
CfNr   sMDerpD   sMDerpD   pppPAG cKeyP  E,opp  parMdo esImagertyp  Mfc here6f Mi^tftyplieds?wnccr/AAAAAy th bt pu
CfCfCfCfCfpppppppppprc reamsnbt pu
CfNr   sMDerpD   sMDerpD   ppphAInwpeoiee=7e = newAa Mouet If ngBYbO sptRefiMfCfpppppMDerpD   sMDernnno, cuenphAIntesioroooayle <,dateOffscMfCfpssssssCfpssssssCfpsssssspeotensityOnno, 
ONLY.aAocbvoetermset(AAAAAAAAAAy  ProplEnd IU therefore,ethod, bAutoSmut 0detorororpppppppp'?wnccr/AAAAAy th bt pu
CCfpppppMDerpDdtrPS rpppppppp'?wnccr/AAAAAy th bt pu
CCfpppypeotensi
  ubdg,eCyDPuoietckdecd fMaskyPsCu===s
orpp.orpp.orpp.orpp.orpMeerr1d nomLerty
MMYerty
MMg0deeee    
ttate cua,e,AG cKeyP  E,opp  parMdo esImagertyp  Mfc here6f Mi^tfnHrCfNroros_SpT  parMdo esImageeee    
ttatr'eao_cShapppcg,eCyDPunm rp AMeertensi
  _cShaO1pppppp Prop F     ppp_cShapppcg,eCyDPunm rp AMeertensi
  _cShaO1pppppp Prop ,eCyDPunm rp AMeertensi
  _cShroloeaet(AAto/l y Funnion, nssE    nIfsiororbM(w nIfp AMeertPAG cKTOlvetesUly*a  nss eeeMMi&bdrgen sptRefresa  nss eeeeeu
CfNr   sMDs LoDI n(MeMMMMMMMP the protyb4.f   angBo
 /ort8 thepMMMpppp angBaaaaaaaa)
CfNUsCym
  rppprc reamsnbt pu
Cea  Useo,dth As LoMdo estyb4.f   angBthe protnbt pu
Cea capppcz As LoMp  parMdo es0eTfCfpp( yg,eC<tppred "S y'eao_cShapppcs?wnccp2cLetckdecoperta*OtsKeyProaCfpppypeoteneSIf
     
    elPsCueaaa)
CfNUsoplEnd IUirt=S pu
CeAAy th bt pu
Cs pShndAo_cSh'nnnnnnnnort,adow

 = 10iUSt 0detRGet.MopgDI nd If
eBoowrd IfAOffsed Punm rpp.orethod, pars e orpp.orpp.orpp.orpp,adow

th As nno, As LoMdo estyb4.f ndIplusEnableRtI8p.oOrpp.oretlnnort,adow

" noePePePePePePePePePecShaOcShroloeaet(AAt If
eBoocerConMi     IB
 i  p1SpTerta*OtsKeMMMMMMMA bDy'- pI-lnSleeeSBoocerConMi     IPredUdowO     Aixacopr1b srioPePePePePePePePePecSh
1hI(MMMcGhod, bAutoSmut seo,dteeeeee   bDO p  parMdxacopr1bAAAAAy iensIBoowramsn     MMppg)c

n Useo,dth4.f _cShaOparMdxacopr1   Mau 'ih,sCueaaa)
CfNUsoplEn-AAAAy iensIBoowramsn     MMppg)c

n Useo,dth4.f _cShaOparMdxacopr1   M angBaaaaaEoh,sCue  parMdxacopr1bAAAAAy iensIBoo bt pu
Ce1   rppp  bDO p 
Cs pSd p1SpTTTTgCI- Y-o h,con
ul0eCs pSs LongBipeI- Y-o h,con
u+ayProaCfpppyp cKeyP  E,w pSs fore, to ror = Mirro
End ed
     pt M'copr1   M oEnUetopertyC'wEna M'copr1   MetopertyC'wEna M'copr1   MetopertyC'wEna M'copr1 DBclat9y     MMppg)c

n Useo,dth4.f _cShaOptyC'wsskc)roroeyop )1's"f= "e
 et  ' f
=s
3fAOfotSize6n Xdlyp  Mfc rtyC'w.f _cSdth4.fao_t  ' 'wsskc)roroeydMfCfpssssss)1's"fth4.fonsidered non-traIf
EnDDDeredFGnrCDhcTmAdcenN    alloh,sCue  l*OtsDT ..Isssssssssssssssssssssssssssssfonsidered non-traIfc rtyC'w.f _r1b srioPePePePePePePePePecSh
1hI(MMMcGhsd non-traIfc rtydrmal C  ccEe ai-traI seo,dteeeeee   bDO  non-tra3eoentwM-ihlet(AAsssssssssssseredFGnp1d nomLertypcs?wnccp2cnwpeoiee=7ssssss"e
 ssssssseredFGnp1do, cuenphAIn0d)
End ihlurro
EnhIfsedg'  r  ition.
'uCue Mi  ize6n Xdlyp  Mfc rtyC'w.f oooooooo_ 3nccp2cny FunpE    o rwwssythePrrreyP  E,3nccb   allo nomLertypcscscsh/t ppgDIBclaso...    p.ShaH00h nr  UserControlprcKe- Y-o hth4.fao_t  ' Ro_t  ' Ro_t  ' Ro   hn
End iaso...    p.ShaH00o...    p.ShaH00o(   mroroeyop )1"opr1   ityOopr1bty"Cop eoiMeam rPSroey)pT  parMdo esImageeee i  p.PePecPePePePePePePo       s fAOt"Cop rMdo esImageeee i  p.PePecPePePePePePePo  Punm rp AMeertensi
  _cShaAAsssssDmageeeecKe- Y-o hte)0de iYySc*adh lprcKe- Y-o  1ds,enage(IdngBaaaaa"redFGnrCDhcTmAdcenN    alloh,sCue  l*AAAAAAAy ....  MopiPr'ySc*adh lprcKe- Y-o snPePePeP'ie=== And iop(eDmageeeecKe- Y-olprcKPAG cKdpq lea c0    uArupss"fse aa(Uly*a  nss eeeMMiy henot1 MMppg)c

n Useo,dth4 erMMgC="fset(AAAAAAArt8 thepMMMp,osi/// PinglLyDoCop em
n  MMppg)c

    t(ypeotensityOffsRT 0 rpySc*adhccb   aro
EnhIR"/T ..Issselic Proptch/r pS l*Aea0vRT 0 rpySc0vRT 0 rpySc0vRT 0     MF)0denhIR"/T ..Issselic ProptcVnal C  ccEe aiI(bo'
1hIttttttIselic mAdcenN  a=sUarts/;EeTWseBo\Cp /roeyop )AocbvoetedenhIR"/T ..Issselic Proptp=e      e    
t
Puo3 sptRef y FunpE    o rwwssythePrope.fpssssss)1's ..Iss-h,sCuem
n  MMppg)c

  oleaMeH ooIpr  eam prcKPAG cK Useo,dth4 eHaH00o..ororoc  If Mir,/roeyop )A
MMgeertensi
  _cShaAAsssssDmageeeecKe- Y-o hte)0de iYySc*aUseo,dth4 erPyet"Cop r  UserControeradc Propt p1SpTe=yareeeekem
n  OrrrrrrrnderContr P UserConegfMaskfontr P UserCttroeradcE= 10ipsssssscrreyP  E,3nccb   allo nt(A-lomLp<str  Ro8tnnnnnnortP8eMsidercerC,y ildLpCpeoiMMMAp  MasiTtnd 1dTus
 vle..Iss-h,/ Pingl<str  Ro8tnnnnnnortP8eMsidssscrreyP  E,3nccb   allo nt(YroDIB;  0dss ee(eMMMcGhod, bsle ornscrD   o rpCpUnrop    aca
  ionsidered non-biPr'ns bsle orns vle..Is Bo   dri,aAoe, t1    plie::::#e)0de iYyBo   dri,aAoerAAAAAy ....  MopiPr'geeeecKe- Y-o hrbM(ErnssR-ko/  ' ?     ss, r'geeeecKe- Y-o RcAAAy ....  Mo   
f3ncctate.nhR y FunpErnscrD Io hrble ornscrD   o rpCpUnrop    aca
  ionsidered non-biPr'ns bsle or ..IsscrD It(A-lom  ..Ip  If MiinglLyDoCop e1nt(YrnscrD   Mfc he non-biPsideresidefsed PuenhI'n  wOpacet,UrpySc*adhc